#PDF_NEWLINE = Chr(10)
#PDF_FONTSUP = -100
#PDF_FONTSUT = 50

#PDF_FONT_TIMES         = "Times-Roman"
#PDF_FONT_TIMESI        = "Times-Italic"
#PDF_FONT_TIMESB        = "Times-Bold"
#PDF_FONT_TIMESBI       = "Times-BoldItalic"
#PDF_FONT_HELVETICA     = "Helvetica"
#PDF_FONT_HELVETICAB    = "Helvetica-Bold"
#PDF_FONT_HELVETICAI    = "Helvetica-Oblique"
#PDF_FONT_HELVETICABI   = "Helvetica-BoldOblique"
#PDF_FONT_COURIER       = "Courier"
#PDF_FONT_COURIERB      = "Courier-Bold"
#PDF_FONT_COURIERI      = "Courier-Oblique"
#PDF_FONT_COURIERBI     = "Courier-BoldOblique"
#PDF_FONT_SYMBOL        = "Symbol"
#PDF_FONT_ZAPFDINGBATS  = "ZapfDingbats"

#PUREPDF_VERSION        = "PurePDF v2.10 for PureBasic v4.10"

Structure PDF_ImageStructure
  N.w
  ImageN.b
  FileName.s
  pMem.l
  MemSize.l
  Width.l
  Height.l
  ColSpace.s
  Bpc.b
  Parms.s
  Pal.MEM_DataStructure
  Datapic.MEM_DataStructure
  Filter.s
EndStructure

Structure PDF_FontStructure
  N.w       
  FontN.b      
  Name$
  Style$
  CharWidth.w[256]  
  FontKey$
  FontEmbed.b ; 1=Font embedding
EndStructure

Structure PDF_FontListStructure
  FontName$
  FontBuffer.l ; Font-Buffer
  FontBuflen.l ; Font-Bufferlength
  FontData.l ; when ipf_PutFonts() is called this is the pointer to the font
EndStructure

Structure PDF_PageLinkStructure
  Page.w  
  DestPage.w
  fA0.f
  fA1.f
  fA2.f
  fA3.f
  y.f
  url$
EndStructure

Structure PDF_TocStructure
  Text$
  Level.w
  Page.w
EndStructure

Global pdfBuffer.MEM_DataStructure
Global pdfState.b
Global pdfPage.w
Global pdfError.l
Global pdfFontSize.f
Global pdfWs.f
Global pdfK.f
Global pdfFontSizePt.b
Global pdfH.f 
Global pdfN.w 
Global pdfX.f                     
Global pdfY.f 
Global pdfLMargin.f         
Global pdfTMargin.f 
Global pdfDefOrientation$ 
Global pdfFontFamily$
Global pdfCurOrientation$
Global pdfWPt.f
Global pdfFwPt.f 
Global pdfHPt.f
Global pdfFhPt.f 
Global pdfW.f
Global pdfFw.f                  
Global pdfFh.f 
Global pdfPageBreakTrigger.f
Global pdfBMargin.f 
Global pdfZoomMode.w
Global pdfLayoutMode$
Global pdfTitle$
Global pdfSubject$
Global pdfAuthor$ 
Global pdfKeywords$
Global pdfCreator$ 
Global pdfAliasNbPages$
Global pdfRMargin.f
Global pdfCMargin.f
Global pdfAutoPageBreak.l
Global pdfInFooter.b               
Global pdfLasth.f                  
Global pdfFontStyle$
Global pdfUnderline.b              
Global pdfDrawColor$
Global pdfFillColor$             
Global pdfTextColor$              
Global pdfColorFlag.b              
Global pdfLineWidth.f
Global pdfNumbering.b
Global pdfNumberingFooter.b
Global pdfNumPageNum.w
Global pdfErrorMessage$ 
Global ASCII85_Width
Global ASCII85_Pos

Global pCompress.l
Global pHeader.l
Global pFooter.l
Global pAcceptPageBreak.l

Global vLocalDecimal.s

;Merge of Mem.pb 9.11.2007 ABBKlaus
ProcedureDLL.b MEM_DataInit(*aData.MEM_DataStructure, aSize.l)
  Protected vReturn.b
  Protected vCurSize.l
  Protected vTmp.l
  
  ;aSize = (Int(aSize/64000)+1)*64000
  aSize=((aSize/64000)+1)*64000
  
  If *aData\pData = 0
    vCurSize = 0
    *aData\pData = AllocateMemory(aSize)
  Else
    vCurSize = *aData\lCurSize
    vTmp = ReAllocateMemory(*aData\pData, aSize)
    If vTmp <> 0 ; *aData\pData
      *aData\pData = vTmp
    EndIf  
  EndIf
    
  If *aData\pData = 0
    vReturn = #False
  Else  
    *aData\lMaxSize = aSize
    *aData\lCurSize = vCurSize
    vReturn = #True
  EndIf  
  
  ProcedureReturn vReturn
EndProcedure

ProcedureDLL.b MEM_DataAdd( *aDest.MEM_DataStructure, *aSource.MEM_DataStructure)
  Protected vSourceSize.l
  Protected vDestSize.l
  Protected vDestMaxSize.l
  
  vSourceSize.l    = *aSource\lCursize  
  vDestSize.l      = *aDest\lCurSize
  vDestMaxSize.l   = *aDest\lMaxsize  
    
  If (vDestMaxSize < (vSourceSize + vDestSize))
    If (MEM_DataInit(*aDest, vSourceSize + vDestSize)) = #False
      ProcedureReturn #False      
    EndIf
    *aDest\lCursize = vDestSize
  EndIf
  
  CopyMemory(*aSource\pData, *aDest\pData + vDestSize , vSourceSize)       
  *aDest\lCursize = vSourceSize + vDestSize   
  ProcedureReturn #True
EndProcedure

ProcedureDLL.b MEM_DataAddString(*aData.MEM_DataStructure, aString.s)  
  Protected vLen.l
  Protected vTmp.MEM_DataStructure
  Protected vReturn.b
   
  vLen = Len(aString)
  *mem=AllocateMemory(vLen+SizeOf(character))
  If *mem
    PokeS(*mem,aString,vLen,#PB_Ascii)
  EndIf
  vTmp\pData = *mem
  vTmp\lCurSize  = vLen
  vTmp\lMaxSize  = vLen
  vReturn = MEM_DataAdd(*aData, vTmp)
  If *mem
    FreeMemory(*mem)
  EndIf
  ProcedureReturn vReturn
EndProcedure

ProcedureDLL.b MEM_DataReplace(*aData.MEM_DataStructure, aSource.s, aDest.s)
  Protected vSourceLen.l
  Protected vDestLen.l
  Protected vCurSize.l
  Protected vMaxSize.l
  Protected vCount.w
  Protected vFind.w
  Protected *tmp.l
  Protected vReturn.b
  
  vSourceLen   = Len(aSource)
  vDestLen     = Len(aDest)
  vCurSize     = *aData\lCursize  
  vMaxSize     = *aData\lMaxsize  
  vFind        = 0

  If (vDestLen > vSourceLen)
    For i = vCurSize To 0 Step -1
      vCount= 0
      For j = 1 To vSourceLen
        If PeekB(*aData\pData + i - vSourceLen + j - 1) = Asc(Mid(aSource,j,1))
          vCount = vCount + 1
        EndIf
      Next 
      If vCount = vSourceLen   
         vFind = vFind + 1   
      EndIf
    Next
    If (vFind > 0)
      MEM_DataInit(*aData, vMaxSize + (vFind*(vDestLen - vSourceLen)))
    EndIf  
  EndIf
  *tmp = AllocateMemory((vDestLen * vCurSize)/vSourceLen)
  If *tmp
    For i = vCurSize To 0 Step -1
      vCount= 0
      For j = 1 To vSourceLen
        If PeekB(*aData\pData + i - vSourceLen + j - 1) = Asc(Mid(aSource,j,1))
          vCount = vCount + 1
        EndIf
      Next 
      If vCount = vSourceLen   
        CopyMemory(*aData\pData + i, *tmp, *aData\lCurSize - i)     
        CopyMemory(@aDest, *aData\pData + i - vSourceLen , vDestLen)          
        CopyMemory(*tmp, *aData\pData + i - vSourceLen + vDestLen, *aData\lCurSize - i) 
        *aData\lCurSize = *aData\lCurSize + (vDestLen-vSourceLen)
      EndIf    
    Next
    FreeMemory(*tmp)
    vReturn = #True
  Else
    vReturn = #False
  EndIf
  ProcedureReturn vReturn
EndProcedure

;28/12/2006 : define decimal seperator
Procedure.s ipf_LocalDecimal()
  Buff.s = Space(10)
  GetLocaleInfo_(#LOCALE_USER_DEFAULT, #LOCALE_SDECIMAL, @Buff, 10)
 ProcedureReturn Buff
EndProcedure

ProcedureDLL.s ipf_StrF(Value.f, NbDecimals = 0)
  Protected vReturn.s
 
  If vLocalDecimal = "."
    vReturn = StrF(Value, NbDecimals)
  Else
    vReturn = ReplaceString(StrF(Value, NbDecimals),vLocalDecimal, ".")
  EndIf
  ProcedureReturn vReturn
EndProcedure

;Constructor
;===========
ProcedureDLL pdf_Init()
  Global NewList Pages.MEM_DataStructure()
  Global NewList Images.PDF_ImageStructure()
  Global NewList Fonts.PDF_FontStructure()
  Global NewList FontList.PDF_FontListStructure()
  Global NewList Offsets.l() 
  Global NewList OrientationChanges.b() 
  Global NewList PageLinks.PDF_PageLinkStructure()
  Global NewList pEndPage.l() 
  Global NewList pPutCatalog.l()
  Global NewList pPutResources.l()
  Global NewList pEndDoc()
  Global NewList pdfTOC.PDF_TocStructure()    
EndProcedure

;Destructor
;==========
ProcedureDLL pdf_End()
  If pdfBuffer\pData
    FreeMemory(pdfBuffer\pData)
  EndIf
  pdfBuffer\pData=0
EndProcedure

Procedure.l ipf_Get_CharWidth(hDC,*Buffer,*Bufferlen)
  ;http://msdn.microsoft.com/library/en-us/gdi/fontext_8icz.asp
  
  ;BOOL GetCharABCWidths(
  ;  HDC hdc,         // handle To DC
  ;  UINT uFirstChar, // first character in range
  ;  UINT uLastChar,  // last character in range
  ;  LPABC lpabc      // array of character widths
  ;);
  If *Buffer=0 Or *Bufferlen=0
    ProcedureReturn #False
  EndIf
  
  Len1=256*12
  Len2=256*2
  Mem1=AllocateMemory(Len1)
  Mem2=AllocateMemory(Len2)
  
  If Mem1>0 And Mem2>0 And GetCharABCWidths_(hDC,0,255,Mem1)
    ;Debug "GetCharABCWidths_ Success"
    For i=0 To 255
      A=PeekL(Mem1+((i*12)+0))
      B=PeekL(Mem1+((i*12)+4))
      C=PeekL(Mem1+((i*12)+8))
      Charwidth=(A+B+C)&$FFFF
      PokeW(Mem2+(i*2),Charwidth)
    Next
    
    PokeL(*Buffer,Mem2)
    PokeL(*Bufferlen,Len2)
    
    FreeMemory(Mem1)
    
    ProcedureReturn #True
  Else
    Debug "GetCharABCWidths_() Failed"
  EndIf
EndProcedure

Procedure.l ipf_Get_Font(hDC,*Buffer,*Bufferlen)
  ;http://msdn.microsoft.com/library/en-us/gdi/fontext_8d7l.asp
  
  ;DWORD GetFontData(
  ;  HDC hdc,           // handle To DC
  ;  DWORD dwTable,     // metric table name
  ;  DWORD dwOffset,    // offset into table
  ;  LPVOID lpvBuffer,  // buffer For returned Data
  ;  DWORD cbData       // length of Data
  ;);
  If *Buffer=0 Or *Bufferlen=0
    ProcedureReturn #False
  EndIf
  
  Len=GetFontData_(hDC,0,0,#Null,#Null)
  If Len=#GDI_ERROR Or Len=-1
    Debug "GDI_ERROR"
  Else
    ;Debug Str(Len)+" Bytes needed for FontData"
    Mem=AllocateMemory(Len)
    If Mem>0 And GetFontData_(hDC,0,0,Mem,Len)<>#GDI_ERROR
      ;Debug "GetFontData Success"
      PokeL(*Buffer,Mem)
      PokeL(*Bufferlen,Len)
      ProcedureReturn #True
    EndIf
  EndIf
EndProcedure

Procedure ipf_ASCII85_Tuple(*NewData.MEM_DataStructure,Tuple.q,Count.l)
  Protected buf.q=0
  Protected i.l=0
  
  Debug "ASCII85_Tuple()"
  
  For i=0 To 5
    PokeB(@buf+i,Tuple%85)
    Tuple=Tuple/85
  Next
  
  For i=Count To 0 Step -1
    PokeB(*NewData\pData+*NewData\lCurSize,PeekB(@buf+i)+33)
    *NewData\lCurSize+1
    ;Result$+Chr(PeekB(@buf+i)+33)
    ASCII85_Pos+1
    If ASCII85_Width And ASCII85_Pos>=ASCII85_Width
      PokeB(*NewData\pData+*NewData\lCurSize,#LF)
      *NewData\lCurSize+1
      ;Result$+#LF$
      Pos=0
    EndIf
  Next
EndProcedure

Procedure.l ipf_ASCII85_Encode(*aData.MEM_DataStructure,WidthP.l=0)
  ASCII85_Width=WidthP
  
  If *aData\pData=0 Or *aData\lCurSize=0
    ProcedureReturn 0
  EndIf
  
  NewData.MEM_DataStructure
  NewData\lCurSize=0
  NewData\lMaxSize=(*aData\lCurSize * 1.3)
  NewData\pData=AllocateMemory(NewData\lMaxSize)
  
  ;EncodedData$="<~"
  ASCII85_Pos=0
  Count=0
  Tuple.q=0
  
  For i=0 To *aData\lCurSize-1
    c=PeekB(*aData\pData+i) & $FF
    
    Select Count
      Case 0
        Tuple|(c<<24)
        Count+1
      Case 1
        Tuple|(c<<16)
        Count+1
      Case 2
        Tuple|(c<<8)
        Count+1
      Case 3
        Tuple|c
        Count+1
        If Tuple=0
          PokeB(NewData\pData+NewData\lCurSize,122)
          NewData\lCurSize+1
          ;EncodedData$+"z"
          ASCII85_Pos+1
          ;Debug "---------z------------"
          If ASCII85_Width And ASCII85_Pos>=ASCII85_Width
            ASCII85_Pos=0
            PokeB(NewData\pData+NewData\lCurSize,#LF)
            NewData\lCurSize+1
            ;EncodedData$+#LF$
          EndIf
        Else
          ipf_ASCII85_Tuple(NewData,Tuple,Count)
          ;EncodedData$+ipf_ASCII85_Tuple(Tuple,Count)
        EndIf
        Tuple=0
        Count=0
    EndSelect
  Next
  
  If Count>0
    ipf_ASCII85_Tuple(NewData,Tuple,Count)
    ;EncodedData$+ipf_ASCII85_Tuple(Tuple,Count)
  EndIf
  
  If ASCII85_Width And ASCII85_Pos+2>ASCII85_Width
    PokeB(NewData\pData+NewData\lCurSize,#LF)
    NewData\lCurSize+1
    ;EncodedData$+#LF$
  EndIf
  
  PokeB(NewData\pData+NewData\lCurSize,126)
  NewData\lCurSize+1
  PokeB(NewData\pData+NewData\lCurSize,62)
  NewData\lCurSize+1
  ;EncodedData$+"~>"
  
  FreeMemory(*aData\pData)
  *aData\pData=NewData\pData
  *aData\lCurSize=NewData\lCurSize
  *aData\lMaxSize=NewData\lMaxSize
  
  ;ProcedureReturn EncodedData$
  ProcedureReturn #True
EndProcedure

ProcedureDLL.f ipf_GetFontSize()
  ProcedureReturn pdfFontSize
EndProcedure

ProcedureDLL.b pdf_GetNumberingFooter()
  ProcedureReturn pdfNumberingFooter
EndProcedure

ProcedureDLL pdf_SetNumberingFooter(Value.b)
  pdfNumberingFooter = Value
EndProcedure

ProcedureDLL pdf_GetNumbering()
  ProcedureReturn pdfNumbering
EndProcedure

ProcedureDLL.f ipf_GetCMargin() ;Get cell margin.
  ProcedureReturn pdfCMargin
EndProcedure

ProcedureDLL.f ipf_GetRMargin() ;Get right margin.
  ProcedureReturn pdfRMargin
EndProcedure

ProcedureDLL.f ipf_GetLMargin() ;Get left margin.
  ProcedureReturn pdfLMargin
EndProcedure

ProcedureDLL.f ipf_GetWs() ;Get word spacing. 
  ProcedureReturn pdfWs
EndProcedure

ProcedureDLL ipf_SetWs(WordSpacing.f) ;Set word spacing. 
  pdfWs = WordSpacing
EndProcedure

ProcedureDLL.f ipf_GetW() ;Get current width of page. 
  ProcedureReturn pdfW
EndProcedure

ProcedureDLL.f ipf_GetH() ;Get current height of page.
  ProcedureReturn pdfH
EndProcedure

ProcedureDLL.f ipf_GetK() ;Get scale factor.
  ProcedureReturn pdfK
EndProcedure

ProcedureDLL.w ipf_GetN() ;Get object number
  ProcedureReturn pdfN
EndProcedure

ProcedureDLL.b ipf_GetFontSizePt() ;Get current fontsize in points.
  ProcedureReturn pdfFontSizePt
EndProcedure

ProcedureDLL ipf_Out(String$) ;Add a line to the document.
  If pdfState = 2
    SelectElement(Pages(), pdfPage - 1)
    MEM_DataAddString(Pages(), String$ + #PDF_NEWLINE)
  Else
    MEM_DataAddString(pdfBuffer, String$ + #PDF_NEWLINE)
  EndIf  
EndProcedure

Procedure ipf_OutStream(*aData.MEM_DataStructure)
  If pdfState = 2
    SelectElement(Pages(), pdfPage - 1)    
    MEM_DataAdd(Pages(), *aData)  
  Else
    MEM_DataAdd(pdfBuffer, *aData)
  EndIf
  ipf_Out("")
EndProcedure 

Procedure ipf_PutStream(*aData.MEM_DataStructure)
  ipf_Out("stream") 
  ipf_OutStream(*aData) 
  ipf_Out("endstream") 
EndProcedure 

ProcedureDLL.s ipf_Escape(String$) ;Add \ before (, ) And \.
  Protected Result$
  Result$ = ReplaceString(String$, "\", "\\")
  Result$ = ReplaceString(Result$, "(", "\(")
  Result$ = ReplaceString(Result$, ")", "\)")
  ProcedureReturn Result$
EndProcedure

ProcedureDLL.s ipf_TextString(String$) ;Format a text string.
  ProcedureReturn "(" + ipf_Escape(String$) + ")"
EndProcedure 

Procedure.l ipf_FileReadInt(MemoryID)
  Protected vResult.l
  vResult = (PeekB(MemoryID) & $FF) << 24
  vResult = vResult + (PeekB(MemoryID + 1) & $FF) << 16
  vResult = vResult + (PeekB(MemoryID + 2) & $FF) << 8
  vResult = vResult + (PeekB(MemoryID + 3) & $FF) 
  ProcedureReturn vResult
EndProcedure 

Procedure.b ipf_ParsePNG(*aData.MEM_DataStructure)
  Protected vReturn.b
  Protected vCt.b
  Protected vCount.l
  Protected vNum.l
  Protected vType.s
  
  vReturn = #True
  Images()\Width = ipf_FileReadInt(*aData\pData+16)
  Images()\Height = ipf_FileReadInt(*aData\pData+20)
  Images()\Bpc = PeekB(*aData\pData+24) & $FF
  If Images()\Bpc>8
    pdfError = 1
    pdfErrorMessage$ = "16-bit depth PNG not supported."
    vReturn = #False
  Else
    vCt = PeekB(*aData\pData+25) & $FF
    Select vCt
      Case 0
        Images()\ColSpace = "DeviceGray"
        Images()\Parms = "/DecodeParms <</Predictor 15 /Colors 1 /BitsPerComponent " + Str(Images()\Bpc) + " /Columns " + Str(Images()\Width) + ">>"  
      Case 2
        Images()\ColSpace = "DeviceRGB" 
        Images()\Parms = "/DecodeParms <</Predictor 15 /Colors 3 /BitsPerComponent " + Str(Images()\Bpc) + " /Columns " + Str(Images()\Width) + ">>"          
      Case 3
        Images()\ColSpace = "Indexed"
        Images()\Parms = "/DecodeParms <</Predictor 15 /Colors 1 /BitsPerComponent " + Str(Images()\Bpc) + " /Columns " + Str(Images()\Width) + ">>"          
      Default:
        pdfError = 2
        pdfErrorMessage$ = "Alpha channel PNG not supported."
        vReturn = #False
    EndSelect
    
    If vReturn = #True
      If (PeekB(*aData\pData+26) & $FF)<>0
        pdfError = 3
        pdfErrorMessage$ = "Unknown compression PNG method."
        vReturn = #False        
      Else
        If (PeekB(*aData\pData+27) & $FF)<>0
          pdfError = 4
          pdfErrorMessage$ = "Unknown filter PNG method."
          vReturn = #False          
        Else
          If (PeekB(*aData\pData+28) & $FF)<>0
            pdfError = 5
            pdfErrorMessage$ = "Interlacing PNG not supported."
            vReturn = #False          
          Else
            ;Scan chunks looking for palette, transparency and image Data
            vNum = 0 : vCount = 33            
            Repeat      
              vNum = ipf_FileReadInt(*aData\pData+vCount)
              vCount = vCount + 4
              vType = Chr(PeekB(*aData\pData+vCount)) + Chr(PeekB(*aData\pData+vCount + 1)) + Chr(PeekB(*aData\pData+vCount + 2)) + Chr(PeekB(*aData\pData+vCount + 3))              
              Select vType
                Case "PLTE"
                  MEM_DataInit(Images()\Pal, Images()\Pal\lCurSize + vNum)
                  CopyMemory(*aData\pData+vCount+4, Images()\Pal\pData + Images()\Pal\lCurSize, vNum)  
                  Images()\Pal\lCurSize = Images()\Pal\lCurSize + vNum                                                          
                Case "IDAT"
                  MEM_DataInit(Images()\DataPic, Images()\DataPic\lCurSize + vNum )
                  CopyMemory(*aData\pData+vCount+4, Images()\DataPic\pData + Images()\DataPic\lCurSize, vNum)                                         
                  Images()\DataPic\lCurSize = Images()\DataPic\lCurSize + vNum                                                          
                Case "IEND"
                  Break
                Default:                                           
              EndSelect           
              vCount = vCount + vNum + 8                  
            Until (vNum<=0)  
            
            If(Images()\ColSpace="Indexed" And Images()\Pal\lCurSize = 0)
              If Images()\Pal\pData
                FreeMemory(Images()\Pal\pData)
              EndIf
              If Images()\DataPic\pData
                FreeMemory(Images()\DataPic\pData)
              EndIf
              pdfError = 6
              pdfErrorMessage$ = "Missing palette in PNG."
              vReturn = #False  
            Else
              pdfError = 0
            EndIf
          EndIf 
        EndIf 
      EndIf
    EndIf   
  EndIf  
  ProcedureReturn vReturn
EndProcedure

Procedure.b ipf_ParseJPG(*aData.MEM_DataStructure)  
  Protected vStart.l
  Protected vLength.l
  Protected vFound.b
  Protected vResult.b

  ;Block Length
  vLength = ((PeekB(*aData\pData + 4) & $FF)*$100) + (PeekB(*aData\pData + 5) & $FF)
  vStart = 4 + vLength     
  vFound = #False
  While (vFound <> #True) And (vStart + 9 < *aData\lCurSize)
    If PeekB(*aData\pData + vStart) = -1 
      If PeekB(*aData\pData + vStart + 1) = -64 
        vFound = #True
        Images()\Bpc = PeekB(*aData\pData + vStart + 4)
        Images()\Height = ((PeekB(*aData\pData + vStart + 5) & $FF)*$100) + (PeekB(*aData\pData + vStart + 6) & $FF)
        Images()\Width =  ((PeekB(*aData\pData + vStart + 7) & $FF)*$100) + (PeekB(*aData\pData + vStart + 8) & $FF)
        ; Gray = 1/Color = 3
        Select PeekB(*aData\pData + vStart + 9) & $FF
          Case 1
            Images()\ColSpace = "DeviceGray"
          Case 3
            Images()\ColSpace = "DeviceRGB"           
          Default:
            Images()\ColSpace = "DeviceCMYK"               
        EndSelect    
        Images()\DataPic\pData = *aData\pData
        Images()\DataPic\lCurSize = *aData\lCurSize
        vResult = #True     
      Else
        ;Block Length
        vLength = ((PeekB(*aData\pData + vStart + 2) & $FF)*$100) + (PeekB(*aData\pData + vStart + 3) & $FF)
        vStart = vStart + vLength + 2
      EndIf      
    Else
      pdfError = 7
      pdfErrorMessage$ = "This JPEG file is not supported."
      vResult = #False
      Break
    EndIf    
  Wend  
  ProcedureReturn vResult
EndProcedure

Procedure ipf_ParseImage(FileName$)
  Protected vReturn.b
  Protected vSize.l
  Protected vData.MEM_DataStructure
  Protected vLength.l
  Protected File.l
  
  vReturn = #True
  
  If Images()\pMem=0
    ; Read Image as File
    File=ReadFile(#PB_Any, FileName$)
    If File
      vSize = FileSize(FileName$)
      MEM_DataInit(vData,vSize)
      vLength = ReadData(File,vData\pData , vSize)
      CloseFile(File)
      vData\lCurSize = vSize
    Else
      vReturn = #False
    EndIf
  Else
    ; Read Image from Mem
    Debug "ipf_ParseImage() Read Image from Mem"
    If Images()\MemSize<>0
      Debug "Mem="+Str(Images()\pMem)
      Debug "MemSize="+Str(Images()\MemSize)
      MEM_DataInit(vData,vSize)
      CopyMemory(Images()\pMem , vData\pData , Images()\MemSize)
      vLength = Images()\MemSize
      vSize = Images()\MemSize
      vData\lCurSize = Images()\MemSize
    Else
      vReturn = #False
    EndIf
  EndIf
  
  If vReturn = #True
    If vLength <> vSize
      pdfError = 9
      pdfErrorMessage$ = "Problem reading image file in memory : " + FileName$ + "."
      If vData\pData
        FreeMemory(vData\pData)
      EndIf
      vReturn = #False
    Else
      ;Check if JPEG
      ;=============
      If PeekB(vData\pData) = -1 And PeekB(vData\pData + 1) = -40
        If PeekB(vData\pData + 2) = -1 And PeekB(vData\pData + 3) = -32  
          Images()\Filter = "DCTDecode"        
          vReturn = ipf_ParseJPG(vData)
        Else
          pdfError = 10
          pdfErrorMessage$ = "JFIF marker is missing."
          vReturn = #False            
        EndIf
      Else
        pdfError = 11
        pdfErrorMessage$ = "Not a JPEG file."
        vReturn = #False  
      EndIf  
      ;Check if PNG
      ;============      
      If vReturn = #False
        If (PeekB(vData\pData) & $FF)=137 And (PeekB(vData\pData+1) & $FF)=80 And (PeekB(vData\pData+2) & $FF)=78 And (PeekB(vData\pData + 3) & $FF)=71 And (PeekB(vData\pData+4) & $FF)=13 And (PeekB(vData\pData+5) & $FF)=10 And (PeekB(vData\pData + 6) & $FF)=26 And (PeekB(vData\pData+7) & $FF)=10
          ;Read Header chunk
          If (PeekB(vData\pData+12) & $FF)=73 And (PeekB(vData\pData+13) & $FF)=72 And (PeekB(vData\pData+14) & $FF)=68 And (PeekB(vData\pData + 15) & $FF)=82
            Images()\Filter = "FlateDecode"
            vReturn = ipf_ParsePNG(vData)
          Else
            pdfError = 12
            pdfErrorMessage$ = "Incorrect PNG file."
          EndIf
        Else
          pdfError = 13
          pdfErrorMessage$ = "Not a JPEG or PNG file."
        EndIf 
      EndIf
      
      If vReturn = #False
        If vData\pData
          FreeMemory(vData\pData)
        EndIf
      EndIf
    EndIf
  Else
    pdfError = 8
    pdfErrorMessage$ = "Can't open image file : " + FileName$ + "."
    vReturn = #False
  EndIf
  
  ProcedureReturn vReturn
EndProcedure

ProcedureDLL.f pdf_GetStringWidth(String$) ;Get width of a string in the current font.
  Protected vLen.l
  Protected vReturn.f
  
  vLen.l   = Len(String$)
  vReturn = 0
  For i=1 To vLen
    If Asc(Mid(String$,i,1))>255
      vReturn = vReturn + 600 ; for Unicode characters
    Else
      vReturn = vReturn + Fonts()\CharWidth[Asc(Mid(String$,i,1))]
    EndIf
  Next

  ProcedureReturn vReturn * (pdfFontSize)/1000
EndProcedure

Procedure.s ipf_DoUnderline(x.f, y.f, Text$)
  Protected vWidth.f
    
  vWidth = pdf_GetStringWidth(Text$) + (pdfWs*CountString(Text$," "))
  ; Take fontstyle into account Bold=Line is double in height
  If CountString(pdfFontStyle$,"B")
    ProcedureReturn ipf_StrF(x*pdfK,2) + " " + ipf_StrF((pdfH-(y-#PDF_FONTSUP/1000*pdfFontSize))*pdfK,2) + " " + ipf_StrF(vWidth*pdfK,2) + " " + ipf_StrF((-#PDF_FONTSUT/1000*pdfFontSizePt)*2,2) + " re f"
  Else
    ProcedureReturn ipf_StrF(x*pdfK,2) + " " + ipf_StrF((pdfH-(y-#PDF_FONTSUP/1000*pdfFontSize))*pdfK,2) + " " + ipf_StrF(vWidth*pdfK,2) + " " + ipf_StrF(-#PDF_FONTSUT/1000*pdfFontSizePt,2) + " re f"
  EndIf
EndProcedure 

ProcedureDLL ipf_NewObj() ;Begin a new object.
  SelectElement(Offsets(), pdfN - 1)
  pdfN = pdfN + 1
  AddElement(Offsets())    
  SelectElement(Offsets(), pdfN - 1)
  Offsets() = pdfBuffer\lCurSize 
  ipf_Out(Str(pdfN) + " 0 obj")
EndProcedure

ProcedureDLL ipf_EndPage() ;End of page contents.
  ForEach pEndPage()    
    CallFunctionFast(pEndPage())
  Next
  pdfState = 1
EndProcedure

Procedure ipf_BeginPage(Orientation$)
  pdfPage = pdfPage + 1
  AddElement(Pages())
  MEM_DataInit(Pages(),64000)
  
  AddElement(OrientationChanges())
  OrientationChanges() = #False
    
  pdfState = 2  
  pdfX = pdfLMargin
  pdfY = pdfTMargin
  pdfFontFamily$ = ""
  
  If Trim(Orientation$) = ""
    Orientation$ = pdfDefOrientation$
  Else
    Orientation$ = Left(UCase(Orientation$),1)
    If Orientation$ <> pdfDefOrientation$
      OrientationChanges() = #True
    EndIf
  EndIf

  If (Orientation$ <> pdfCurOrientation$)
    ; Change orientation
    If Orientation$ = "P"
      pdfWPt = pdfFwPt
      pdfHPt = pdfFhPt
      pdfW = pdfFw
      pdfH = pdfFh
    Else
      pdfWPt = pdfFhPt
      pdfHPt = pdfFwPt
      pdfW = pdfFh
      pdfH = pdfFw    
    EndIf
    pdfPageBreakTrigger = pdfH - pdfBMargin    
    pdfCurOrientation$ = Orientation$
  EndIf  
EndProcedure

Procedure ipf_BeginDoc()
  pdfState = 1  
  ipf_Out("%PDF-1.5")
EndProcedure

Procedure ipf_PutTrailer()
  ipf_Out("/Size " + Str(pdfN + 1))
  ipf_Out("/Root " + Str(pdfN) + " 0 R")  
  ipf_Out("/Info " + Str(pdfN - 1) + " 0 R") 
  If encrypted 
    ;$this->_out('/Encrypt '.$this->enc_obj_id.' 0 R'); 
    ipf_Out("/Encrypt " + Str(enc_obj_id) + " 0 R") 
    ;$this->_out('/ID [()()]'); 
    ipf_Out("/ID [()()]") 
  EndIf 
EndProcedure

Procedure ipf_PutCatalog()
  ipf_Out("/Type /Catalog")
  ipf_Out("/Pages 1 0 R")
  Select pdfZoomMode
    Case #PDF_ZOOM_FULLPAGE
      ipf_Out("/OpenAction [3 0 R /Fit]")
    Case #PDF_ZOOM_FULLWIDTH
      ipf_Out("/OpenAction [3 0 R /FitH null]")
    Case #PDF_ZOOM_REAL
      ipf_Out("/OpenAction [3 0 R /XYZ null null 1]")
    Default:
      ipf_Out("/OpenAction [3 0 R /XYZ null null " + ipf_StrF(pdfZoomMode/100,2) +  "]")
  EndSelect    
  ipf_Out("/PageLayout " + pdfLayoutMode$)
  ForEach pPutCatalog()    
    CallFunctionFast(pPutCatalog())
  Next
EndProcedure

Procedure ipf_PutFonts()
  Protected tempfontname$
  Protected HexData$

  ;Font Data
  ForEach FontList()
    ipf_NewObj()
    FontList()\FontData=pdfN
    ipf_Out("<<")
    ZIP=0
    If pCompress > 0
      packmem.MEM_DataStructure
      packmem\pData=FontList()\FontBuffer
      packmem\lMaxSize=FontList()\FontBuflen
      packmem\lCurSize=FontList()\FontBuflen
      If CallFunctionFast(pCompress,packmem)
        If 1=1
          ;Store encoded data
          ipf_Out("/Filter /FlateDecode")
          ipf_Out("/Length "+Str(packmem\lCurSize+2))
          ipf_Out("/Length1 "+Str(FontList()\FontBuflen))
          FontList()\FontBuffer=packmem\pData
          FontList()\FontBuflen=packmem\lCurSize+2
          ipf_Out(">>")
          ipf_PutStream(packmem)
        Else
          ;ASCII85 encode the zipped data
          packmem\lCurSize+2
          ipf_ASCII85_Encode(packmem)
          ipf_Out("/Filter [/ASCII85Decode/FlateDecode]")
          ipf_Out("/Length "+Str(packmem\lCurSize))
          ipf_Out("/Length1 "+Str(FontList()\FontBuflen))
          FontList()\FontBuffer=packmem\pData
          FontList()\FontBuflen=packmem\lCurSize+2
          ipf_Out(">>")
          ipf_PutStream(packmem)
        EndIf
        ZIP=1
      EndIf
    EndIf
    If ZIP=0
      ;encode with ASCII85
      ASCII85.MEM_DataStructure
      ASCII85\pData=FontList()\FontBuffer
      ASCII85\lCurSize=FontList()\FontBuflen
      ASCII85\lMaxSize=FontList()\FontBuflen
      ipf_ASCII85_Encode(ASCII85)
      FontList()\FontBuffer=ASCII85\pData
      ipf_Out("/Filter /ASCII85Decode")
      ipf_Out("/Length "+Str(ASCII85\lCurSize))
      ipf_Out("/Length1 "+Str(FontList()\FontBuflen))
      ipf_Out(">>")
      ipf_PutStream(ASCII85)
    EndIf
    ipf_Out("endobj")
    
    ;Free memory of FontData
    FreeMemory(FontList()\FontBuffer)
  Next
  
  ForEach Fonts()
    tempfontname$=ReplaceString(Fonts()\Name$," ","#20")
    If Fonts()\Fontembed
      ;Font Width
      ipf_NewObj()
      FontWidth=pdfN
      ipf_Out("[")
      For j=0 To 255 Step 16
        HexData$=""
        For i=0 To 15
          HexData$+Str(Fonts()\CharWidth[j+i])+" "
        Next
        ipf_Out(HexData$)
      Next
      ipf_Out("]")
      ipf_Out("endobj")
      ;Font Descriptor
      ipf_NewObj()
      FontDescriptor=pdfN
      ipf_Out("<</Type/FontDescriptor")
      ipf_Out("/FontName/"+tempfontname$)
      ipf_Out("/Flags 4")
      ipf_Out("/FontBBox [0 0 0 0]")
      ForEach FontList()
        If UCase(FontList()\FontName$)=UCase(Fonts()\Name$)
          ipf_Out("/FontFile2 " + Str(FontList()\FontData) + " 0 R")
          Break
        EndIf
      Next
      ipf_Out(">>")
      ipf_Out("endobj")
    EndIf
    
    If Fonts()\Fontembed
      ;Embedded font
      ipf_NewObj()
      Fonts()\N = pdfN
      ipf_Out("<</Type/Font")
      ipf_Out("/Subtype/TrueType")
      ipf_Out("/Name/F" + Str(Fonts()\FontN))
      ipf_Out("/BaseFont/"+tempfontname$)
      ipf_Out("/Encoding/WinAnsiEncoding")
      ipf_Out("/FirstChar 0")
      ipf_Out("/LastChar 255")
      ipf_Out("/Widths " + Str(FontWidth) + " 0 R")
      ipf_Out("/FontDescriptor " + Str(FontDescriptor) + " 0 R")
      ipf_Out(">>")
      ipf_Out("endobj")
    Else
      ;Standard font
      ipf_NewObj()
      Fonts()\N = pdfN
      ipf_Out("<</Type/Font")
      ipf_Out("/BaseFont/" + tempfontname$)
      ipf_Out("/Subtype/Type1")
      If (Fonts()\Name$<> #PDF_FONT_SYMBOL And Fonts()\Name$<> #PDF_FONT_ZAPFDINGBATS)
        ipf_Out("/Encoding/WinAnsiEncoding")
      EndIf
      ipf_Out(">>")
      ipf_Out("endobj")
    EndIf
  Next
EndProcedure

Procedure ipf_SetFontData(FontName$,Style$,FontKey$)
  Protected vCharWidth.w , vDefault.b , vStyle.l , vFound.b , Font.l , hDC.l , Mem.l , Len.l , j.l, fontNS$
  
  AddElement(Fonts())
  Fonts()\FontN = CountList(Fonts())
  Fonts()\FontKey$ = FontKey$
  Fonts()\Style$ = Style$
  vDefault = #False
  
  fontNS$=UCase(FontName$+Style$)         
  Select fontNS$
    Case "COURIER"
      Fonts()\Name$ = #PDF_FONT_COURIER
      vDefault = #True
    Case "COURIERB"
      Fonts()\Name$ = #PDF_FONT_COURIERB
      vDefault = #True
    Case "COURIERI"
      Fonts()\Name$ = #PDF_FONT_COURIERI
      vDefault = #True
    Case "COURIERBI"
      Fonts()\Name$ = #PDF_FONT_COURIERBI
      vDefault = #True                  
    Case "HELVETICA"  
      Fonts()\Name$ = #PDF_FONT_HELVETICA
      Restore Helvetica                      
    Case "HELVETICAB"  
      Fonts()\Name$ = #PDF_FONT_HELVETICAB
      Restore HelveticaB
    Case "HELVETICAI"  
      Fonts()\Name$ = #PDF_FONT_HELVETICAI
      Restore HelveticaI     
    Case "HELVETICABI"  
      Fonts()\Name$ = #PDF_FONT_HELVETICABI
      Restore HelveticaBI 
    Case "ZAPFDINGBATS"  
      Fonts()\Name$ = #PDF_FONT_ZAPFDINGBATS
      Restore Zapfdingbats   
    Case "TIMES"  
      Fonts()\Name$ = #PDF_FONT_TIMES
      Restore Times
    Case "TIMESI"  
      Fonts()\Name$ = #PDF_FONT_TIMESI
      Restore TimesI    
    Case "TIMESBI"  
      Fonts()\Name$ = #PDF_FONT_TIMESBI
      Restore TimesBI      
    Case "TIMESB"  
      Fonts()\Name$ = #PDF_FONT_TIMESB
      Restore TimesB   
    Case "SYMBOL"  
      Fonts()\Name$ = #PDF_FONT_SYMBOL
      Restore Symbol
    Default ; Font is unknown = Font embedding
      vDefault = 3
  EndSelect
  
  Select vDefault
    Case #True
      For j = 0 To 255  
        Fonts()\CharWidth[j] = 600
      Next
      Fonts()\FontEmbed=0
    Case #False
      For j = 0 To 255
        Read vCharWidth
        Fonts()\CharWidth[j] = vCharWidth
      Next
      Fonts()\FontEmbed=0
    Case 3 ; Embed the Font
      Fonts()\FontEmbed=1
      
      vStyle=0
      Select Style$
        Case "B"
          vStyle|#PB_Font_Bold
        Case "I"
          vStyle|#PB_Font_Italic
        Case "BI","IB"
          vStyle|#PB_Font_Bold|#PB_Font_Italic
      EndSelect
      
      If pdfUnderline
        vStyle|#PB_Font_Underline
      EndIf
      
      Font=LoadFont(#PB_Any,FontName$,750,vStyle)
      hDC=CreateDC_("DISPLAY",#Null,#Null,#Null)
      SelectObject_(hDC,FontID(Font))
      TMBuflen=GetOutlineTextMetrics_(hDC,0,0)
      If TMBuflen>0
        *TM.OUTLINETEXTMETRIC=AllocateMemory(TMBuflen)
        If *TM
          GetOutlineTextMetrics_(hDC,TMBuflen,*TM)
          ;temp1$=PeekS(*TM+*TM\otmpFamilyName)
          If #PB_Compiler_Unicode
            
            adr=PeekL(*TM+204)
            FontName$=PeekS(*TM+adr) ; due to a bug in the TEXTMETRIC structure (PB4.01) *TM\otmpFaceName
            ;MessageRequester(FontName$,Str(*TM\otmpFaceName+4),0)
            
          Else
            FontName$=PeekS(*TM+*TM\otmpFaceName)
          EndIf
          ;temp3$=PeekS(*TM+*TM\otmpStyleName)
          ;temp4$=PeekS(*TM+*TM\otmpFullName)
          
          FreeMemory(*TM)
        EndIf
      EndIf
      
      Fonts()\Name$ = FontName$
      
      vFound=#False
      ForEach FontList()
        If FontList()\FontName$ = FontName$
          vFound=#True
          Break
        EndIf
      Next
      
      ; if Font is not already defined load it into memory
      If vFound=#False
        Mem=0:Len=0
        If ipf_Get_Font(hDC,@Mem,@Len)
          AddElement(FontList())
          FontList()\FontName$=Fonts()\Name$
          FontList()\FontBuffer=Mem
          FontList()\FontBuflen=Len
          FontList()\FontData=0
        EndIf
      EndIf
      
      ;FontWidth
      Mem=0:Len=0
      If ipf_Get_CharWidth(hDC,@Mem,@Len)
        If Mem<>0
          For j = 0 To 255
            Fonts()\CharWidth[j] = PeekW(Mem+(j*2))
          Next
          FreeMemory(Mem)
        Else
          For j = 0 To 255
            Fonts()\CharWidth[j] = 600
          Next
        EndIf
      EndIf
      If hDC
        DeleteDC_(hDC)
      EndIf    
  EndSelect
EndProcedure

Procedure ipf_PutInfo()
  ipf_Out("/Producer " + ipf_TextString(#PUREPDF_VERSION))
  If Trim(pdfTitle$) <> ""
    ipf_Out("/Title " + ipf_TextString(pdfTitle$))
  EndIf
  If Trim(pdfSubject$) <> ""
    ipf_Out("/Subject " + ipf_TextString(pdfSubject$))
  EndIf
  If Trim(pdfAuthor$) <> ""
    ipf_Out("/Author " + ipf_TextString(pdfAuthor$))
  EndIf
  If Trim(pdfKeywords$) <> ""
    ipf_Out("/Keywords " + ipf_TextString(pdfKeywords$))
  EndIf
  If Trim(pdfCreator$) <> ""
    ipf_Out("/Creator " + ipf_TextString(pdfCreator$))
  EndIf
  tmp$ = "D:" + FormatDate("%yyyy%mm%dd%hh%ii%ss", Date())
  ipf_Out("/CreationDate " + ipf_TextString(tmp$))
EndProcedure

Procedure ipf_PutImages()
  ForEach Images()
    ipf_NewObj()
    Images()\N = pdfN
    ipf_Out("<</Type /XObject")
    ipf_Out("/Subtype /Image")
    ipf_Out("/Width " + Str(Images()\Width))
    ipf_Out("/Height " + Str(Images()\Height))
    If Images()\ColSpace = "Indexed"
      ipf_Out("/ColorSpace [/Indexed /DeviceRGB " + Str(Images()\Pal\lCurSize/3 - 1) + " " + Str(pdfN + 1) + " 0 R]")            
    Else  
      ipf_Out("/ColorSpace /" + Images()\ColSpace)
      If Images()\ColSpace = "DeviceCMYK"
        ipf_Out("/Decode [1 0 1 0 1 0 1 0]")
      EndIf
    EndIf
    ipf_Out("/BitsPerComponent " + Str(Images()\Bpc))
    ipf_Out("/Filter /" + Images()\Filter)
    If Images()\Parms <> ""
      ipf_Out(Images()\Parms)
    EndIf
    ipf_Out("/Length "  + Str(Images()\Datapic\lCurSize) + ">>")
    ipf_PutStream(Images()\Datapic)
    ipf_Out("endobj")
    ;Palette
    If(Images()\ColSpace="Indexed")
      ipf_NewObj()
      ipf_Out("<<"+"/Length "+ Str(Images()\Pal\lCurSize)+">>")     
      ipf_PutStream(Images()\Pal)
      ipf_Out("endobj")
    EndIf
    If Images()\Pal\pData
      FreeMemory(Images()\Pal\pData)
    EndIf
    If Images()\Datapic\pData
      FreeMemory(Images()\Datapic\pData)
    EndIf
  Next
EndProcedure

Procedure ipf_PutResources()
  ipf_PutFonts()
  ipf_PutImages()
  ;Resource dictionary
  SelectElement(Offsets(),1)
  Offsets() = pdfBuffer\lCurSize
  ipf_Out("2 0 obj")
  ipf_Out("<<")
  ipf_Out("/ProcSet [/PDF /Text /ImageB /ImageC /ImageI]")
  ipf_Out("/Font <<")
  ForEach Fonts()
    ipf_Out("/F" + Str(Fonts()\FontN) + " " + Str(Fonts()\N) + " 0 R")
  Next
  ipf_Out(">>")
  If (CountList(Images()) > 0)
    ipf_Out("/XObject <<")
    ForEach Images()
      ipf_Out("/I" + Str(Images()\ImageN) + " " + Str(Images()\N) + " 0 R")
    Next
    ipf_Out(">>")
  EndIf  
  ipf_Out(">>")
  ipf_Out("endobj")   
  
  ForEach pPutResources()    
    CallFunctionFast(pPutResources())
  Next
EndProcedure

Procedure ipf_PutPages()
  Protected lwTotalPages.w, i.w
  Protected lsAnnots.s
  Protected lsRect.s
  Protected lsKids.s
  Protected lh.f
  Protected lsFilter.s

  lwTotalPages = pdfPage
 
    If (pdfAliasNbPages$ <> "")
    ; Replace number of pages
    For i = 1 To lwTotalPages 
      SelectElement(Pages(), i-1)
      MEM_DataReplace(Pages(), pdfAliasNbPages$, Str(lwTotalPages))
    Next
  EndIf
  
  If (pdfDefOrientation$="P")
    pdfWPt = pdfFwPt
    pdfHPt = pdfFhPt
  Else
    pdfwPt = pdfFhPt
    pdfhPt = pdfFwPt
  EndIf
  
  If pCompress > 0
    lsFilter = "/Filter /FlateDecode "
  EndIf  
  For i = 1 To lwTotalPages 
    ipf_NewObj()
    ipf_Out("<</Type /Page")
    ipf_Out("/Parent 1 0 R")
    SelectElement(OrientationChanges(),i-1)
    If OrientationChanges() = #True
      ipf_Out("/MediaBox [0 0 " + ipf_StrF(pdfHPt,2) + " " + ipf_StrF(pdfWPt,2) + "]")
    EndIf
    lh  = pdfH
    ipf_Out("/Resources 2 0 R")
    lsAnnots = "/Annots ["
    ForEach PageLinks()
      If (PageLinks()\Page = i)            
        lsRect = ipf_StrF(PageLinks()\fA0,2) + " " + ipf_StrF(PageLinks()\fA1,2) + " " + ipf_StrF(PageLinks()\fA0 + PageLinks()\fA2,2) + " "
        lsRect = lsRect + ipf_StrF(PageLinks()\fA1 - PageLinks()\fA3,2)
        lsAnnots = lsAnnots + "<</Type /Annot /Subtype /Link /Rect [" +lsRect + "] /Border [0 0 0] "
        If (Trim(PageLinks()\url$) <> "")
          lsAnnots = lsAnnots + "/A <</S /URI /URI " + ipf_TextString(PageLinks()\url$) + ">>>>"
        Else  
          SelectElement(OrientationChanges(), PageLinks()\Page - 1) 
          If OrientationChanges() = #True
            pdfH = pdfWPt
          Else
            pdfH = pdfHPt
          EndIf
          lsAnnots = lsAnnots + "/Dest [" + Str(1+2*PageLinks()\DestPage) 
          lsAnnots = lsAnnots + " 0 R /XYZ 0 " + ipf_StrF(pdfH - PageLinks()\y*pdfK,2)
          lsAnnots = lsAnnots + " null]>>"           
        EndIf          
      EndIf    
    Next   
    
    pdfH = lh
    If lsAnnots <> "/Annots ["
      ipf_Out(lsAnnots + "]") 
    EndIf
    ipf_Out("/Contents " + Str(pdfN + 1) + " 0 R>>")
    ipf_Out("endobj")
    ; Page content
    SelectElement(Pages(), i - 1)
    If pCompress > 0
      CallFunctionFast(pCompress, Pages())
    EndIf
    ipf_NewObj()
    ipf_Out("<<" + lsFilter + "/Length " + Str(Pages()\lCurSize) + ">>")
    ipf_PutStream(Pages())
    ipf_Out("endobj")
    If Pages()\pData
      FreeMemory(Pages()\pData)
    EndIf
  Next
  ; Pages root 
  SelectElement(Offsets(), 0)
  Offsets() = pdfBuffer\lCurSize   
  ipf_Out("1 0 obj")
  ipf_Out("<</Type /Pages")
  lsKids = "/Kids ["

  For i=0 To lwTotalPages-1
    lsKids = lsKids + Str(3 + 2*i) + " 0 R "
  Next
  
  ipf_Out(lsKids + "]")
  ipf_Out("/Count " + Str(lwTotalPages))
  ipf_Out("/MediaBox [0 0 " + ipf_StrF(pdfWPt,2) + " " + ipf_StrF(pdfHPt,2) + "]")
  ipf_Out(">>")
  ipf_Out("endobj") 
EndProcedure

Procedure ipf_EndDoc()
  ipf_PutPages();
  ipf_PutResources();
  ;Info
  ipf_NewObj() 
  ipf_Out("<<")
  ipf_PutInfo()
  ipf_Out(">>")
  ipf_Out("endobj")
  ;Catalog
  ipf_NewObj()
  ipf_Out("<<")
  ipf_PutCatalog()
  ipf_Out(">>")
  ipf_Out("endobj")
  ;Cross-ref
  startxref = pdfBuffer\lCurSize  
  ipf_Out("xref")
  ipf_Out("0 " + Str(pdfN+1))
  ipf_Out("0000000000 65535 f ")
  For i=1 To pdfN    
    SelectElement(Offsets(), i-1)
    ipf_Out(RSet(Str(Offsets()), 10, "0") + " 00000 n ")
  Next
  ;Trailer
  ipf_Out("trailer")
  ipf_Out("<<")
  ipf_PutTrailer()
  ipf_Out(">>")
  ipf_Out("startxref")
  ipf_Out(Str(startxref))
  ipf_Out("%%EOF")
  pdfState=3  
  
  ForEach pEndDoc()    
    CallFunctionFast(pEndDoc())
  Next   
  
  ;Cleanup
  ClearList(Pages())
  ClearList(Offsets())
  ClearList(OrientationChanges())
  ClearList(PageLinks()) 
  ClearList(Fonts())
  ClearList(FontList())
  ClearList(Images())
  
  ;ClearList(pEndPage()) ; -> now in pdfMisc
  ;ClearList(pPutCatalog()) ; -> now in pdfMisc
  ;ClearList(pPutResources()) ; -> now in pdfMisc
  ;ClearList(pEndDoc()) ; -> now in pdfMisc
  
  ClearList(pdfTOC())
EndProcedure

Procedure pdf_SetMarginsBasic(LeftMargin.f, TopMargin.f, RightMargin.f)
  pdfLMargin = LeftMargin
  pdfTMargin = TopMargin
  If(RightMargin=-1)
    RightMargin = LeftMargin
  EndIf
  pdfRMargin = RightMargin
EndProcedure

ProcedureDLL pdf_SetMargins(LeftMargin.f, TopMargin.f) ;Set left, top and right margins.
  pdf_SetMarginsBasic(LeftMargin, TopMargin, -1)
EndProcedure

ProcedureDLL pdf_SetMargins2(LeftMargin.f, TopMargin.f, RightMargin.f) ;Set left, top and right margins.
  pdf_SetMarginsBasic(LeftMargin, TopMargin, RightMargin)
EndProcedure

ProcedureDLL pdf_SetLeftMargin(LeftMargin.f) ;Set left margin.
  pdfLMargin = LeftMargin
  If(pdfPage>0 And pdfX<LeftMargin)
    pdfX=LeftMargin
  EndIf
EndProcedure

ProcedureDLL pdf_SetTopMargin(TopMargin.f) ;Set top margin.
   pdfTMargin = TopMargin
EndProcedure

ProcedureDLL pdf_SetRightMargin(RightMargin.f) ;Set right margin.
  pdfRMargin = RightMargin
EndProcedure

ProcedureDLL pdf_SetCellMargin(CellMargin.f) ;Set cell margin.
  pdfCMargin = CellMargin
EndProcedure

Procedure pdf_SetAutoPageBreakBasic(Auto.l, Margin.f)
  pdfAutoPageBreak = Auto
  pdfBMargin = Margin
  pdfPageBreakTrigger = pdfH - Margin
EndProcedure

ProcedureDLL pdf_SetAutoPageBreak(Auto.l) ;Set auto page break mode and triggering margin.
  pdf_SetAutoPageBreakBasic(Auto, 0)
EndProcedure

ProcedureDLL pdf_SetAutoPageBreak2(Auto.l, Margin.f) ;Set auto page break mode and triggering margin.
  pdf_SetAutoPageBreakBasic(Auto, Margin)
EndProcedure

Procedure pdf_SetDisplayModeBasic(Zoom.w, Layout$)
  pdfZoomMode = Zoom  
  Select Layout$
    Case #PDF_LAYOUT_SINGLE
    Case #PDF_LAYOUT_CONTINUOUS
    Case #PDF_LAYOUT_TWO 
    Default:
      Layout$ = #PDF_LAYOUT_CONTINUOUS
  EndSelect
  pdfLayoutMode$ = Layout$
EndProcedure

ProcedureDLL pdf_SetDisplayMode(Zoom.w) ;Set display mode in viewer.
  PDF_SetDisplayModeBasic(Zoom, #PDF_LAYOUT_CONTINUOUS)
EndProcedure

ProcedureDLL pdf_SetDisplayMode2(Zoom.w, Layout$) ;Set display mode in viewer.
  PDF_SetDisplayModeBasic(Zoom, Layout$)
EndProcedure

Procedure pdf_CreateBasic(Orientation$, Unit$, Format$)  
  Protected lfMargin.f
  
  vLocalDecimal = ipf_LocalDecimal()
  
  pHeader = 0
  pFooter = 0
  pAcceptPageBreak = 0
  pCompress = 0

  AddElement(Offsets())
  AddElement(Offsets())
  
  If pdfBuffer\pData
    FreeMemory(pdfBuffer\pData)
  EndIf
  pdfBuffer\pData = 0
  MEM_DataInit(pdfBuffer, 63999)
  If Orientation$ = "" : Orientation$ = "P" : EndIf
  If Unit$ = "" : Unit$  = "mm" : EndIf
  If Format$ = "" : Format$ = #PDF_PAGE_FORMAT_A4 :EndIf 

  pdfPage = 0 
  pdfN = 2
  pdfState = 0
  pdfInFooter = #False
  pdfLasth = 0
  pdfFontFamily$=""
  pdfFontStyle$=""
  pdfFontSizePt=12
  pdfUnderline=#False
  pdfDrawColor$="0 G"
  pdfFillColor$="0 g"
  pdfTextColor$="0 g"
  pdfColorFlag=#False
  pdfWs=0
  pdfError = 0
  pdfErrorMessage$ = ""
  
  pdfNumbering = #False
  pdfNumberingFooter = #False
  pdfNumPageNum = 1 
  
  ;Scale factor
  Select Unit$
    Case "pt"
      pdfK = 1
    Case "mm"
      pdfK = 72/25.4
    Case "cm"
      pdfK = 72/2.54
    Case "in"
      pdfK = 72
    Default:
      pdfK = 72/25.4
  EndSelect   
  
  ;Page format
  pdfFwPt = ValF(StringField(Format$, 1, ","))
  pdfFhPt = ValF(StringField(Format$, 2, ","))      
  pdfFw = pdfFwPt/pdfK
  pdfFh = pdfFhPt/pdfK
 
  ;Page orientation
  Orientation$=UCase(Orientation$)
  If (Orientation$ ="L" Or Orientation$ = "LANDSCAPE")
    pdfDefOrientation$="L"
    pdfWPt = pdfFhPt
    pdfHPt = pdfFwPt
  Else
    pdfDefOrientation$="P"
    pdfWPt = pdfFwPt
    pdfHPt = pdfFhPt 
  EndIf 
  pdfCurOrientation$ = pdfDefOrientation$
  pdfW = pdfWPt/pdfK
  pdfH = pdfHPt/pdfK
  
  ;Page margins (1 cm)
  lfMargin=28.35/pdfK
  pdf_SetMarginsBasic(lfMargin,lfMargin,-1)
  ;Interior cell margin (1 mm)
  pdfCMargin =  lfMargin/10
  ;Line width (0.2 mm)
  pdfLineWidth = 0.567/pdfK  
  ;Automatic page Break
  pdf_SetAutoPageBreakBasic(#True ,2*lfMargin)
  ;Full width display mode
  pdf_SetDisplayModeBasic(#PDF_ZOOM_FULLWIDTH, #PDF_LAYOUT_CONTINUOUS)  

  If(pdfState=0)
    ipf_BeginDoc()
  EndIf           
EndProcedure

ProcedureDLL.b pdf_Create() ;Begin document.
  ProcedureReturn pdf_CreateBasic("", "", "")
EndProcedure

ProcedureDLL.b pdf_Create2(Orientation$) ;Begin document.
  ProcedureReturn pdf_CreateBasic(Orientation$, "", "")
EndProcedure

ProcedureDLL.b pdf_Create3(Orientation$, Unit$) ;Begin document.
  ProcedureReturn pdf_CreateBasic(Orientation$, Unit$, "")
EndProcedure

ProcedureDLL.b pdf_Create4(Orientation$, Unit$, Format$) ;Begin document.
  ProcedureReturn pdf_CreateBasic(Orientation$, Unit$, Format$)  
EndProcedure

ProcedureDLL pdf_SetProcCompression(ProcAddress.l) ;Set compression procedure.
  pCompress = ProcAddress
EndProcedure

ProcedureDLL pdf_SetProcHeader(ProcAddress.l) ;Set header procedure.
  pHeader = ProcAddress
EndProcedure

ProcedureDLL pdf_SetProcFooter(ProcAddress.l) ;Set footer procedure.
  pFooter = ProcAddress
EndProcedure

ProcedureDLL pdf_SetProcAcceptPageBreak(ProcAddress.l) ;Set acceptpagebreak procedure.
  pAcceptPageBreak = ProcAddress
EndProcedure

ProcedureDLL ipf_SetProcEndPage(ProcAddress.l) ;Set endpage procedure.
  AddElement(pEndPage())
  pEndPage() = ProcAddress
EndProcedure

ProcedureDLL ipf_SetProcEndDoc(ProcAddress.l) ;Set enddoc procedure.
  AddElement(pEndDoc())
  pEndDoc() = ProcAddress
EndProcedure

ProcedureDLL ipf_SetProcPutCatalog(ProcAddress.l) ;Set putcatalog procedure.
  AddElement(pPutCatalog())
  pPutCatalog() = ProcAddress
EndProcedure

ProcedureDLL ipf_SetProcPutResources(ProcAddress.l) ;Set putresources procedure.
  AddElement(pPutResources())
  pPutResources() = ProcAddress
EndProcedure

ProcedureDLL ipf_ClearProcEndPage() ;Clears the endpage commands
  ClearList(pEndPage())
EndProcedure

ProcedureDLL ipf_ClearProcEndDoc() ;Clears the enddoc commands
  ClearList(pEndDoc())
EndProcedure

ProcedureDLL ipf_ClearProcCatalog() ;Clears the catalog commands
  ClearList(pPutCatalog())
EndProcedure

ProcedureDLL ipf_ClearProcResources() ;Clears the resource commands
  ClearList(pPutResources())
EndProcedure

ProcedureDLL pdf_SetTitle(Title$) ;Defines the title of the document.
  pdfTitle$ = Title$
EndProcedure

ProcedureDLL pdf_SetSubject(Subject$) ;Defines the subject of the document.
  pdfSubject$ = subject$
EndProcedure

ProcedureDLL pdf_SetAuthor(Author$) ;Defines the author of the document.
  pdfAuthor$ = Author$
EndProcedure

ProcedureDLL pdf_SetKeywords(Keywords$) ;Associates keywords with the document, generally in the form 'keyword1 keyword2 ...'.
  pdfKeywords$ = keywords$
EndProcedure

ProcedureDLL pdf_SetCreator(Creator$) ; Defines the creator of the document.
  pdfCreator$ = creator$
EndProcedure

Procedure pdf_AliasNbPagesBasic(Alias$)  
  If Alias$ = "" 
    Alias$ = "{nb}"
  EndIf  
  pdfAliasNbPages$=Alias$
EndProcedure

ProcedureDLL pdf_AliasNbPages() ;Defines an alias for the total number of pages.
  pdf_AliasNbPagesBasic("{nb}")
EndProcedure

ProcedureDLL pdf_AliasNbPages2(Alias$) ;Defines an alias for the total number of pages.
  pdf_AliasNbPagesBasic(Alias$)
EndProcedure

ProcedureDLL.w pdf_GetPageNo() ;Returns the current page number.
  ProcedureReturn pdfPage
EndProcedure

ProcedureDLL.f pdf_GetY() ;Returns the ordinate of the current position.
  ProcedureReturn pdfY
EndProcedure

ProcedureDLL.f pdf_GetX() ;Returns the abscissa of the current position.
  ProcedureReturn pdfX
EndProcedure

ProcedureDLL pdf_SetX(X.f) ;Defines the abscissa of the current position.
  If(x>=0)
    pdfX = x
  Else
    pdfX = pdfW + x
  EndIf
EndProcedure 

ProcedureDLL pdf_SetY(Y.f) ;Moves the current abscissa back to the left margin and sets the ordinate.
  pdfX = pdfLMargin
  If(y>=0)
    pdfY = y
  Else
    pdfY = pdfH + y
  EndIf
EndProcedure 

ProcedureDLL pdf_SetXY(X.f,Y.f) ;Defines the abscissa and ordinate of the current position.
  pdf_SetY(y)
  pdf_SetX(x)
EndProcedure

ProcedureDLL.l pdf_AcceptPageBreak() ;Accept automatic page break or not
  If (pAcceptPageBreak>0)
    ProcedureReturn CallFunctionFast(pAcceptPageBreak)  
  Else
    ProcedureReturn pdfAutoPageBreak
  EndIf  
EndProcedure

Procedure pdf_SetTextColorbasic(Red.f,Green.f,Blue.f)
  ;Set color For text
  If((Red=0 And Green=0 And Blue=0) Or Green=-1)
    pdfTextColor$= ipf_StrF(Red/255,3) + " g"
  Else
    pdfTextColor$= ipf_StrF(Red/255,3) + " " + ipf_StrF(Green/255,3) + " " + ipf_StrF(Blue/255,3) + " rg"
  EndIf  
  If (pdfFillColor$ <> pdfTextColor$)
    pdfColorFlag = #True
  EndIf
EndProcedure

Procedure pdf_SetDrawColorBasic(Red.f,Green.f,Blue.f)
  ;Set color For all stroking operations  
  If(((Red=0) And (Green=0) And (Blue=0)) Or (Green=-1))
    pdfDrawColor$= ipf_StrF(Red/255,3) + " G"
  Else
    pdfDrawColor$= ipf_StrF(Red/255,3) + " " + ipf_StrF(Green/255,3) + " " + ipf_StrF(Blue/255,3) + " RG"
  EndIf
  If (pdfPage > 0)
    ipf_Out(pdfDrawColor$)
  EndIf
EndProcedure

Procedure pdf_SetFillColorbasic(Red.f,Green.f,Blue.f)
  ;Set color For all filling operations
  If((Red=0 And Green=0 And Blue=0) Or Green=-1)
    pdfFillColor$= ipf_StrF(Red/255,3) + " g"
  Else
    pdfFillColor$= ipf_StrF(Red/255,3) + " " + ipf_StrF(Green/255,3) + " " + ipf_StrF(Blue/255,3) + " rg"
  EndIf  
  If (pdfFillColor$ <> pdfTextColor$)
    pdfColorFlag = #True
  EndIf
  If(pdfPage>0)
    ipf_Out(pdfFillColor$)
  EndIf
EndProcedure

ProcedureDLL pdf_SetTextColor(Red.f) ;Set color for text.
  pdf_SetTextColorBasic(Red, -1, -1)
EndProcedure

ProcedureDLL pdf_SetTextColor2(Red.f, Green.f) ;Set color for text.
  pdf_SetTextColorBasic(Red, Green, -1)
EndProcedure

ProcedureDLL pdf_SetTextColor3(Red.f, Green.f, Blue.f) ;Set color for text.
  pdf_SetTextColorBasic(Red, Green, Blue)
EndProcedure

ProcedureDLL pdf_SetDrawColor(Red.f) ;Set color for all stroking operations.
  pdf_SetDrawColorBasic(Red, -1, -1)
EndProcedure

ProcedureDLL pdf_SetDrawColor2(Red.f, Green.f) ;Set color for all stroking operations.
  pdf_SetDrawColorBasic(Red, Green, -1)
EndProcedure

ProcedureDLL pdf_SetDrawColor3(Red.f, Green.f, Blue.f) ;Set color for all stroking operations.
  pdf_SetDrawColorBasic(Red, Green, Blue)
EndProcedure

ProcedureDLL pdf_SetFillColor(Red.f) ;Set color for all filling operations.
  pdf_SetFillColorBasic(Red, -1, -1)
EndProcedure

ProcedureDLL pdf_SetFillColor2(Red.f, Green.f) ;Set color for all filling operations.
  pdf_SetFillColorBasic(Red, Green, -1)
EndProcedure

ProcedureDLL pdf_SetFillColor3(Red.f, Green.f, Blue.f) ;Set color for all filling operations.
  pdf_SetFillColorBasic(Red, Green, Blue)
EndProcedure

Procedure pdf_LnBasic(Height.f)
  pdfX = pdfLMargin
  pdfY = pdfY + Height
EndProcedure

ProcedureDLL pdf_Ln() ;Performs a line break.
  pdf_LnBasic(pdfLasth)
EndProcedure

ProcedureDLL pdf_Ln2(Height.f) ;Performs a line break.
  pdf_LnBasic(Height)
EndProcedure

Procedure pdf_SetFontBasic(Family$, Style$, Size.b)
  Protected vFontKey.s
  Protected vFound.b
  Protected uFamily$=UCase(Family$)
  
  ; Select a font, size given in points
  Family$ = Trim(Family$)
  If Family$ = ""
    Family$ = pdfFontFamily$    
  EndIf
  Select uFamily$
    Case "ARIAL"
      Family$ = "HELVETICA"
    Case "SYMBOL"
      Style$ = ""
    Case "ZAPFDINGBATS"
      Style$ = ""  
  EndSelect
  
  Style$ = Trim(UCase(Style$))
  If (FindString(Style$,"U",1) > 0)
    pdfUnderline = #True
    Style$ = ReplaceString(Style$, "U", "")
  Else
    pdfUnderline =#False
  EndIf    
  If Style$ = "IB"
    Style$ = "BI"
  EndIf
  
  If Size = 0
    Size = pdfFontSizePt
  EndIf
  
  ;Test if font is already selected
  If (UCase(pdfFontFamily$) = UCase(Family$) And pdfFontStyle$ = Style$ And pdfFontSizePt = Size)
    ;Do nothing
  Else
    ;Test if used For the first time
    vFontKey = UCase(RSet(Style$,3,"_")+"+"+Family$) ; BI_+Fontname
    vFound = #False
    ForEach Fonts()
      If (Fonts()\Fontkey$ = vFontKey)
        vFound = #True
        Break
      EndIf
    Next
    If vFound = #False
      ipf_SetFontData(Family$,Style$,vFontKey)
    EndIf
    ; Select it
    pdfFontFamily$ = Family$
    pdfFontStyle$ = Style$
    pdfFontSizePt = Size
    pdfFontSize = Size/pdfK
    If (pdfPage >0)
      ipf_Out("BT /F" + Str(Fonts()\FontN) + " " + ipf_StrF(pdfFontSizePt,2) + " Tf ET")
    EndIf
  EndIf
EndProcedure

ProcedureDLL pdf_SetFont(Family$) ;Sets the font used to print character strings.
  pdf_SetFontbasic(Family$,"",0)
EndProcedure

ProcedureDLL pdf_SetFont2(Family$, Style$) ;Sets the font used to print character strings.
  pdf_SetFontbasic(Family$, Style$,0)
EndProcedure

ProcedureDLL pdf_SetFont3(Family$, Style$, Size.b) ;Sets the font used to print character strings.
  pdf_SetFontbasic(Family$, Style$, Size)
EndProcedure

Procedure pdf_AddPageBasic(Orientation$)
  Protected lsFamily.s
  Protected lsStyle.s
  Protected lbSize.b
  Protected lfLw.f
  Protected lsdc.s
  Protected lsfc.s
  Protected lstc.s
  Protected lbcf.b
   ;Start a new page
  If(pdfState=0)
    pdf_CreateBasic("", "", "")
  EndIf
  lsFamily = pdfFontFamily$
  lsStyle = pdfFontStyle$
  If pdfUnderline = #True
    lsStyle = lsStyle + "U"
  EndIf  
  lbSize = pdfFontSizePt
  lflw = pdfLineWidth
  lsdc = pdfDrawColor$
  lsfc = pdfFillColor$
  lstc = pdfTextColor$
  lbcf = pdfColorFlag
  
  If(pdfPage>0)
    ;Page footer
    pdfInFooter = #True
    If pFooter > 0
      CallFunctionFast(pFooter)
    EndIf
    pdfInFooter = #False
    ;Close page
    ipf_EndPage()
  EndIf
      
  ;Start new page
  ipf_BeginPage(Orientation$)
  ;Set line cap style To square
  ipf_Out("2 J")
  ;Set line width
  pdfLineWidth = lflw
  ipf_Out(ipf_StrF(lflw * pdfK,2) + " w")
  ;Set font
  If(Trim(lsFamily) <> "")
      pdf_SetFontBasic(lsFamily, lsStyle, lbSize)
  EndIf  
  ;Set colors
  pdfDrawColor$ = lsdc 
  If (lsdc <> "0 G")
    ipf_Out(lsdc)
  EndIf  
  pdfFillColor$ = lsfc
  If (lsfc <> "0 g")
    ipf_Out(lsfc)
  EndIf  
  pdfTextColor$ = lstc
  pdfColorFlag = lbcf
  ; Page header
  If pHeader > 0
    CallFunctionFast(pHeader)
  EndIf
  ;Restore line width
  If(pdfLineWidth<>lflw)
    pdfLineWidth = lflw
    ipf_Out(ipf_StrF(lflw*pdfK,2) + " w")
  EndIf
  ; Restore font
  If(lsFamily <> "")
    pdf_SetFontBasic(lsFamily,lsStyle,lbSize)
  EndIf  
  ;Restore colors
  If(pdfDrawColor$ <> lsdc)
    pdfDrawColor$=lsdc
    ipf_Out(lsdc)
  EndIf
  If(pdfFillColor$ <> lsfc)
    pdfFillColor$ = lsfc
    ipf_Out(lsfc)
  EndIf
  pdfTextColor$ = lstc
  pdfColorFlag = lbcf  
  
  If pdfNumbering=#True
    pdfNumPageNum = pdfNumPageNum + 1
  EndIf
EndProcedure

ProcedureDLL pdf_AddPage() ;Adds a new page to the document.
  pdf_AddPageBasic("")
EndProcedure

ProcedureDLL pdf_AddPage2(Orientation$) ;Adds a new page to the document.
  pdf_AddPageBasic(Orientation$)
EndProcedure

Procedure ipf_Close() ;Terminates the PDF document.
  ;Terminate document
  If(pdfState=3)
    ;Do nothing
  Else
    If(pdfPage=0)
      pdf_AddPageBasic("")
    EndIf  
    ;Page footer
    pdfInFooter=#True 
    If pFooter > 0
      CallFunctionFast(pFooter)
    EndIf
    pdfInFooter=#False
    ;Close page
    ipf_EndPage();
    ;Close document
    ipf_EndDoc()
  EndIf
EndProcedure

ProcedureDLL pdf_Save(FileName$) ;Output PDF to filename.
  ipf_Close()
  If CheckFilename(GetFilePart(Filename$)) = 1
    File=CreateFile(#PB_Any, FileName$)
    If File
      WriteData(File,pdfBuffer\pData, pdfBuffer\lCurSize)
      CloseFile(File)
    Else
      pdfError = 15
      pdfErrorMessage$ = "Can't create the file."
    EndIf      
  Else
    pdfError = 14
    pdfErrorMessage$ = "Filename is not correct."
  EndIf
  If pdfBuffer\pData
    FreeMemory(pdfBuffer\pData)
  EndIf
  pdfBuffer\pData=0    
EndProcedure

ProcedureDLL pdf_Text(X.f,Y.f,Text$) ;Prints a character string.
  String$ = "BT " + ipf_StrF(x*pdfK,2) + " " + ipf_StrF((pdfH - y)*pdfK,2) + " Td (" + ipf_Escape(Text$) + ") Tj ET"
  If (pdfUnderline = #True) And (Text$ <> "")
    String$ = String$ + " " + ipf_DoUnderline(x,y,Text$)
  EndIf
  If pdfColorFlag= #True
    String$ = "q " + pdfTextColor$ + " " + String$ + " Q"
  EndIf
  ipf_Out(String$)
EndProcedure   

ProcedureDLL pdf_SetLineWidth(Width.f) ;Defines the line width.
  pdfLineWidth = Width
  If(pdfPage>0)
    ipf_Out(ipf_StrF(Width*pdfK,2) + " w")
  EndIf
EndProcedure

ProcedureDLL pdf_Line(X1.f,Y1.f,X2.f,Y2.f) ;Draws a line between two points.
  ipf_Out(ipf_StrF(x1*pdfK,2) + " " + ipf_StrF((pdfH-y1)*pdfK,2) + " m " + ipf_StrF(x2 * pdfK,2) + " " + ipf_StrF((pdfH-y2)*pdfK,2) + " l S")
EndProcedure

Procedure pdf_RectBasic(x.f,y.f,w.f,h.f,Style$)
  Protected vOp.s
  ;Draw a rectangle
  Select Style$
    Case #PDF_STYLE_FILL
      vOp="f"
    Case #PDF_STYLE_DRAWANDFILL
      vOp="B"
    Default: 
      vOp="S"
  EndSelect
  ipf_Out(ipf_StrF(x*pdfK,2) + " " + ipf_StrF((pdfH-y)*pdfK,2) + " " + ipf_StrF(w*pdfK,2) + " " + ipf_StrF(-h*pdfK,2) + " re " + vOp)
EndProcedure

ProcedureDLL pdf_Rect(X.f,Y.f,W.f,H.f) ;Outputs a rectangle.
  pdf_rectbasic(x,y,w,h,"")
EndProcedure

ProcedureDLL pdf_Rect2(X.f,Y.f,W.f,H.f,Style$) ;Outputs a rectangle.
  pdf_rectbasic(x,y,w,h,style$)
EndProcedure

ProcedureDLL pdf_SetFontSize(Size.b) ;Defines the size of the current font.
  If(pdfFontSizePt<>Size)
    pdfFontSizePt = size
    pdfFontSize = size/pdfK
    If pdfPage > 0
      ipf_Out("BT /F" + Str(fonts()\FontN) + " " + ipf_StrF(pdfFontSizePt,2) + " Tf ET")  
    EndIf
  EndIf
EndProcedure

ProcedureDLL.w pdf_Addlink() ;Creates a new internal link and returns its identifier.
  AddElement(PageLinks())
  ProcedureReturn CountList(PageLinks())
EndProcedure

Procedure pdf_SetLinkBasic(pLink.w, y.f, page.w, url$)
  If(y=-1)
    y = pdfY
  EndIf
  If page=-1
    page = pdfPage
  EndIf
  SelectElement(PageLinks(),pLink)
  PageLinks()\DestPage = page
  PageLinks()\Y = y
  PageLinks()\Url$ = url$
EndProcedure

ProcedureDLL pdf_SetLink(Link.w) ;Defines the page and position a link points to.
  pdf_SetLinkBasic(Link,-1,-1,"")
EndProcedure

ProcedureDLL pdf_SetLink2(Link.w, Y.f) ;Defines the page and position a link points to.
  pdf_SetLinkBasic(Link,y,-1,"")
EndProcedure

ProcedureDLL pdf_SetLink3(Link.w, Y.f, Page.w) ;Defines the page and position a link points to.
  pdf_SetLinkBasic(Link,y,page,"")
EndProcedure

ProcedureDLL pdf_SetLink4(Link.w, Y.f, Page.w, Url$) ;Defines the page and position a link points to.
  pdf_SetLinkBasic(Link,y,page,url$)
EndProcedure

ProcedureDLL pdf_Link(X.f, Y.f, W.f, H.f, Link.w) ;Puts a link on a rectangular area of the page.
  SelectElement(PageLinks(), link) 
  PageLinks()\fA0 = x*pdfK
  PageLinks()\fA1 = pdfFhPt - y*pdfK
  PageLinks()\fA2 = w*pdfK
  PageLinks()\fA3 = h*pdfK
  PageLinks()\Page = pdfPage
EndProcedure

Procedure pdf_CellBasic(w.f,h.f=0,Text$="",Border.w=0,Ln.f=0,Align$="",Fill.f=0,Link.w=-1)
  ;Output a cell
  Protected l_k.f
  Protected l_x.f
  Protected l_y.f
  Protected l_ws.f
  Protected l_s.s
  Protected l_op.s
  Protected l_dx.f, wmax.f, wlink.f
  Protected l_txt.s
  Protected TextLen.f

  l_k = pdfK  
  If( (pdfY+h > pdfPageBreakTrigger) And (pdfInFooter=#False) And (pdf_AcceptPageBreak()=#True))
    ;Automatic page Break    
    l_x = pdfX
    l_ws = pdfWs
    If(l_ws>0)
      pdfWs=0
      ipf_Out("0 Tw")
    EndIf
    pdf_AddPageBasic(pdfCurOrientation$)  
    pdfX = l_x
    If(l_ws>0)
      pdfWs=l_ws
      ipf_Out(ipf_StrF(l_ws*l_k,3) + " Tw")
    EndIf  
  EndIf
  If (w=0)
    w = pdfW - pdfRMargin - pdfX
  EndIf  
  l_s = ""
  If (Fill=1 Or Border = 1)  
    If(Fill=1)
      If (Border = 1)
        l_op = "B"
      Else
        l_op = "f"
      EndIf    
    Else  
      l_op="S"
    EndIf  
    
    l_s = ipf_StrF(pdfX*l_k,2) + " " + ipf_StrF((pdfH-pdfY)*l_k,2) + " " + ipf_StrF(w*l_k,2) + " " + ipf_StrF(-H*l_k,2) + " re " + l_op + " "
  EndIf
  If Border < 0
    l_x=pdfX
    l_y=pdfY
    ;L
    If -Border & -#PDF_CELL_LEFTBORDER
      l_s=l_s + ipf_StrF(l_x*l_k,2) + " " + ipf_StrF((pdfH - l_y)*l_k,2) + " m " + ipf_StrF(l_x*l_k,2) + " " + ipf_StrF((pdfH-(l_y+H))*l_k,2) + " l S "
    EndIf
    ;T
    If -Border & -#PDF_CELL_TOPBORDER
      l_s=l_s + ipf_StrF(l_x*l_k,2) + " " + ipf_StrF((pdfH - l_y)*l_k,2) + " m " + ipf_StrF((l_x+W)*l_k,2) + " " + ipf_StrF((pdfH- l_y)*l_k,2) + " l S "    
    EndIf
    ;R
    If -Border & -#PDF_CELL_RIGHTBORDER
      l_s=l_s + ipf_StrF((l_x+W)*l_k,2) + " " + ipf_StrF((pdfH - l_y)*l_k,2) + " m " + ipf_StrF((l_x+W)*l_k,2) + " " + ipf_StrF((pdfH- (l_y+H))*l_k,2) + " l S "        
    EndIf 
    ;B
    If -Border & -#PDF_CELL_BOTTOMBORDER
      l_s=l_s + ipf_StrF(l_x*l_k,2) + " " + ipf_StrF((pdfH - (l_y+H))*l_k,2) + " m " + ipf_StrF((l_x+W)*l_k,2) + " " + ipf_StrF((pdfH- (l_y+H))*l_k,2) + " l S "    
    EndIf  
  EndIf 
  If (Text$ <> "")  
    TextLen = pdf_GetStringWidth(Text$)  
    If (Align$ = #PDF_ALIGN_RIGHT)
      l_dx = W - pdfCMargin - TextLen
    ElseIf (Align$ = #PDF_ALIGN_CENTER)  
      l_dx = (W - TextLen)/2
    ElseIf (Align$ = #PDF_ALIGN_FORCEDJUSTIFIED)
      wmax = W - (2 * pdfCMargin)   
      pdfWs = (wmax-TextLen)   
      If CountString(Text$," ")> 0
        pdfWs = pdfWs/CountString(Text$," ")              
      EndIf
      ipf_Out(ipf_StrF((pdfWs*pdfK),3) + " Tw")
      l_dx = pdfCMargin      
    Else
      l_dx = pdfCMargin
    EndIf  
    Text$= ipf_Escape(Text$) 
    If (pdfColorFlag = #True)
      l_s = l_s + "q " + pdfTextColor$ + " "      
    EndIf
    l_s = l_s + "BT " + ipf_StrF((pdfX+l_dx)*l_k,2) + " " + ipf_StrF(((pdfH-(pdfY+0.5*H+0.3*pdfFontSize))*l_k) ,2) + " Td (" + Text$ + ") Tj ET"        
    If(pdfUnderline)
      l_s = l_s  + " " 
      l_s = l_s +  ipf_DoUnderline(pdfX + l_dx, pdfY + 0.5*H+0.3*pdfFontSize,Text$)
    EndIf
    If pdfColorFlag = #True
      l_s = l_s + " Q"
    EndIf  
    If Link >= 0
      If Align$ = #PDF_ALIGN_FORCEDJUSTIFIED
        wLink = wmax
      Else
        wlink = pdf_GetStringWidth(Text$)
      EndIf   
      pdf_Link(pdfX+l_dx,pdfY+0.5*H-0.5*pdfFontSize,wlink,pdfFontSize,Link)
    EndIf 
  EndIf
  If (l_s<>"")   
    ipf_Out(l_s)
  EndIf  
  If Align$ = #PDF_ALIGN_FORCEDJUSTIFIED
    ipf_Out("0 Tw")
    pdfWs = 0
  EndIf
  pdfLasth = H
  If (Ln>0)
    ;Go To Next line
    pdfY = pdfY + H
    If (Ln=1)
      pdfX = pdfLMargin
    EndIf  
  Else
    pdfX = pdfX + W
  EndIf      
EndProcedure

ProcedureDLL pdf_Cell(W.f) ;Prints a cell (rectangular area) with optional borders, background color and character string.
  pdf_CellBasic(w)
EndProcedure

ProcedureDLL pdf_Cell2(W.f ,H.f ) ;Prints a cell (rectangular area) with optional borders, background color and character string.
  pdf_CellBasic(w,h)
EndProcedure

ProcedureDLL pdf_Cell3(W.f ,H.f, Text$ ) ;Prints a cell (rectangular area) with optional borders, background color and character string.
  pdf_CellBasic(w,h,Text$)
EndProcedure

ProcedureDLL pdf_Cell4(W.f ,H.f ,Text$, Border.w) ;Prints a cell (rectangular area) with optional borders, background color and character string.
  pdf_CellBasic(w,h,Text$,border)
EndProcedure

ProcedureDLL pdf_Cell5(W.f ,H.f ,Text$, Border.w, Ln.f) ;Prints a cell (rectangular area) with optional borders, background color and character string.
  pdf_CellBasic(w,h,Text$,border,ln)
EndProcedure

ProcedureDLL pdf_Cell6(W.f ,H.f ,Text$, Border.w, Ln.f, Align$) ;Prints a cell (rectangular area) with optional borders, background color and character string.
  pdf_CellBasic(w,h,Text$,border,ln,Align$)
EndProcedure

ProcedureDLL pdf_Cell7(W.f ,H.f ,Text$, Border.w, Ln.f, Align$, Fill.f) ;Prints a cell (rectangular area) with optional borders, background color and character string.
  pdf_CellBasic(w,h,Text$,border,ln,Align$,fill)
EndProcedure

ProcedureDLL pdf_Cell8(W.f ,H.f ,Text$, Border.w, Ln.f, Align$, Fill.f, Link.w) ;Prints a cell (rectangular area) with optional borders, background color and character string.
  pdf_CellBasic(w,h,Text$,border,ln,Align$,fill,link)
EndProcedure

Procedure.s pdf_MultiCellBasic(w.f,h.f,Text$,Border.w,Align$,fill.f, indent.f, maxline.w) 
  Protected wMax.f, wMaxOther.f, wFirst.f, wOther.f, wMaxFirst.f 
  Protected s.s 
  Protected nb.l 
  Protected first.b 
  Protected savex.f 
  Protected b.w
  Protected b2.w
  ;Output text with automatic Or explicit line breaks 
  If(w=0) 
    w=pdfW - pdfRMargin - pdfX 
  EndIf 
  
  wFirst = w - indent
  wOther = w  
  wMaxFirst = (wFirst-2*pdfCMargin)*1000/pdfFontSize 
  wMaxOther = (wOther-2*pdfCMargin)*1000/pdfFontSize
  s = Text$
  nb  = Len(s) 
  If(nb>0 And Right(s,1) = #PDF_NEWLINE) 
    nb = nb - 1 
  EndIf 
  b = 0 
  If Border <> 0 
    If(Border=1) 
      Border= #PDF_CELL_LEFTBORDER + #PDF_CELL_RIGHTBORDER + #PDF_CELL_TOPBORDER + #PDF_CELL_BOTTOMBORDER 
      b= #PDF_CELL_LEFTBORDER + #PDF_CELL_RIGHTBORDER + #PDF_CELL_TOPBORDER 
      b2=#PDF_CELL_LEFTBORDER + #PDF_CELL_RIGHTBORDER 
    Else 
      b2=0 
      If -Border & -#PDF_CELL_LEFTBORDER
        b2=b2+#PDF_CELL_LEFTBORDER 
      EndIf 
      If -Border & -#PDF_CELL_RIGHTBORDER
        b2=b2+#PDF_CELL_RIGHTBORDER 
      EndIf 
      If -Border & -#PDF_CELL_TOPBORDER
        b2=b2+#PDF_CELL_TOPBORDER 
      EndIf 
      b=b2 
    EndIf  
  EndIf 
  sep=-1 
  i=1 
  j=0 
  l=0 
  ns=0 
  nl=1 
  c.s=""
  first = #True
  While(i<nb) 
    ;Get Next character 
    c = Mid(s,i,1)    
    If c = Chr(10)
            
      ;Explicit line Break 
      If(pdfWs>0)      
        pdfWs=0 
        ipf_Out("0 Tw") 
      EndIf 
      pdf_CellBasic(w,h,Mid(s,j,i-j),b,2,align$,fill,-1) 
      i = i + 1 
      sep = -1 
      j=i  
      l=0 
      ns=0 
      nl= nl +1 
      If nl=2 And Border <>0 
        b=b2 
      EndIf  
      Continue 
    EndIf 
    If(c=" ") 
      sep = i 
      ls = l 
      ns=ns+1    
    EndIf 
    l=l+fonts()\CharWidth[Asc(c)]  
    
    If first = #True
      wMax = wMaxFirst
      w = wFirst
    Else
      wMax = wMaxOther
      w = wOther
    EndIf
    
    If l>wmax 
      ;Automatic line Break 
      If(sep=-1) 
        If(i=j) 
          i = i +1 
        EndIf  
        If(pdfWs>0) 
          pdfWs=0 
          ipf_Out("0 Tw") 
        EndIf 
        saveX = pdfX
        If (first=#True And indent > 0)
          pdf_SetX(pdfX + indent) 
          first = #False 
        EndIf             
        pdf_CellBasic(w,h,Mid(s,j,i-j),b,2,align$,fill,-1)      
      Else 
        If(align$="J") 
          If (ns>1) 
             pdfWs = (wmax-ls)/1000*pdfFontSize/(ns-1) 
          Else 
             pdfWs = 0 
          EndIf 
          ipf_Out(ipf_StrF(pdfWs*pdfK,3) + " Tw") 
        EndIf  
        saveX = pdfX
        If (first=#True And indent > 0)
          pdf_SetX(pdfX + indent) 
          first = #False 
        EndIf         
        pdf_CellBasic(w,h,Mid(s,j,sep-j),b,2,align$,fill,-1) 
        If (first = #False) 
          pdf_SetX(saveX) 
        EndIf 
        i=sep +1 
      EndIf 
      sep=-1; 
      j=i; 
      l=0; 
      ns=0; 
      nl = nl +1 
      If(Border <> 0 And nl=2) 
        b=b2; 
      EndIf 
      If (maxLine > 0 And nl > maxLine)
        ProcedureReturn Right(s, Len(s) - i)
      EndIf 
    Else 
      i=i+1 
    EndIf 
  Wend  
  ;Last chunk 
   If(pdfWs>0) 
     pdfWs=0 
     ipf_Out("0 Tw"); 
   EndIf 
   If -Border & -#PDF_CELL_BOTTOMBORDER And border <> 0
     b=b+#PDF_CELL_BOTTOMBORDER 
   EndIf 
   pdf_CellBasic(w,h,Mid(s,j,i-j + 1),b,2,align$,fill,-1) 
   pdfX=pdfLMargin 
   ProcedureReturn ""
EndProcedure

ProcedureDLL.s pdf_MultiCell(W.f, H.f, Text$) ;This method allows printing text with line breaks.
  ProcedureReturn pdf_MultiCellBasic(w,h,Text$,0,"J",0,0,0)
EndProcedure

ProcedureDLL.s pdf_MultiCell2(W.f, H.f, Text$, Border.w) ;This method allows printing text with line breaks.
  ProcedureReturn pdf_MultiCellBasic(w,h,Text$,border,"J",0,0,0)
EndProcedure

ProcedureDLL.s pdf_MultiCell3(W.f, H.f, Text$, Border.w,Align$) ;This method allows printing text with line breaks.
  ProcedureReturn pdf_MultiCellBasic(w,h,Text$,border,Align$,0,0,0)
EndProcedure

ProcedureDLL.s pdf_MultiCell4(W.f, H.f, Text$, Border.w,Align$, Fill.f) ;This method allows printing text with line breaks.
  ProcedureReturn pdf_MultiCellBasic(w,h,Text$,border,Align$,Fill,0,0)
EndProcedure

ProcedureDLL.s pdf_MultiCell5(W.f, H.f, Text$, Border.w,Align$, Fill.f, Indent.f) ;This method allows printing text with line breaks.
  ProcedureReturn pdf_MultiCellBasic(w,h,Text$,border,Align$,Fill,indent,0)
EndProcedure

ProcedureDLL.s pdf_MultiCell6(W.f, H.f, Text$, Border.w,Align$, Fill.f, Indent.f, Maxline.w) ;This method allows printing text with line breaks.
  ProcedureReturn pdf_MultiCellBasic(w,h,Text$,border,Align$,Fill,indent,maxline)
EndProcedure

Procedure pdf_WriteBasic(h.f, Text$, link.w)
  ;Output text in flowing mode
  Protected c.s
  Protected s.s
  Protected w.f
  Protected wmax.f
  Protected l.f
  
  w = pdfW - pdfRMargin - pdfX
  wmax = (w - 2 * pdfCMargin) * 1000 / pdfFontSize
  s = Text$
;  s = ReplaceString(txt,"\r","")
  nb = Len(s)
  sep = -1
  i=1
  j=1
  l=0
  nl=1
  
  While (i<=nb)
    ;Get Next character
    c = Mid(Text$,i,1)
    If c = #PDF_NEWLINE
      ;Explicit line Break
      pdf_CellBasic(w, h, Mid(Text$, j, i-j), 0, 2, "", 0, link)
      i = i + 1
      sep = -1
      j = i
      l = 0
      If (nl = 1)
        pdfX = pdfLMargin
        w = pdfW - pdfRMargin - pdfX
        wmax = (w - 2 * pdfCMargin) * 1000 / pdfFontSize
      EndIf
      nl = nl + 1
      Continue
    EndIf
    If (c = " "  )
      sep = i
    EndIf
    l = l + Fonts()\CharWidth[Asc(c)]
    If (l>wmax)
      ;Automatic line Break
      If (sep = -1)
        If (pdfX > pdfLMargin)  
          ;Move To Next line
          pdfX = pdfLMargin
          pdfY = pdfY + h
          w = pdfW - pdfRMargin - pdfX
          wmax = (w - 2 * pdfCMargin) * 1000 / pdfFontSize
          i = i + 1
          nl = nl + 1
          Continue
        EndIf
        If (i=j)
          i = i + 1
        EndIf  
        pdf_CellBasic(w,h,Mid(Text$,j,i-j),0,2,"",0,link)  
      Else
        pdf_CellBasic(w,h,Mid(Text$,j,sep-j),0,2,"",0,link)  
        i = sep + 1
      EndIf  
      sep = -1
      j=i
      l=0
      If (nl=1)
        pdfX = pdfLMargin
        w = pdfW - pdfRMargin - pdfX
        wmax = (w - 2 * pdfCMargin) * 1000 / pdfFontSize
      EndIf
      nl = nl + 1
    Else
      i = i + 1
    EndIf
  Wend
  ;Last chunk
  If (i<>j)
    pdf_cellBasic(l/1000*pdfFontSize, h, Mid(Text$,j,Len(Text$)), 0, 0, "", 0, link)         
  EndIf
EndProcedure    

ProcedureDLL pdf_Write(H.f, Text$) ;This method prints text from the current position.
  pdf_WriteBasic(h.f, Text$, -1)
EndProcedure

ProcedureDLL pdf_Write2(H.f, Text$, Link.w) ;This method prints text from the current position.
  pdf_WriteBasic(h.f, Text$, link.w)
EndProcedure

Procedure.l pdf_ImageBasic(FileName$,*Mem,MemSize,x.f,y.f,w.f,h.f, link.w)
  Protected msg.s
  Protected lbFound.b
  
  msg = ""
  lbFound = #False
  ;Put an image on the page
  ForEach Images()
    If Images()\FileName = FileName$
      lbFound = #True
      Break
    EndIf  
  Next
  
  If lbFound = #False
    AddElement(Images())
    Images()\FileName = FileName$
    Images()\pMem = *Mem
    Images()\MemSize = MemSize
    Images()\ImageN = CountList(Images())  
    If ipf_ParseImage(FileName$) = #False
      DeleteElement(Images())
      ProcedureReturn 0
    EndIf  
  EndIf 
  ;Automatic width And height calculation If needed
  If w= 0 And h = 0
    ;Put image at 72 dpi
    w = images()\Width/pdfK
    h = images()\Height/pdfK    
  EndIf
  If w = 0
    w = h*images()\Width/images()\Height
  EndIf
  If h = 0
    h = w*images()\Height/images()\Width
  EndIf

  msg = "q " + ipf_StrF(w*pdfK,2) + " 0 0 " + ipf_StrF(h*pdfK,2) + " " + ipf_StrF(x*pdfK,2) + " "
  msg = msg + ipf_StrF((pdfH-(y+h))*pdfK,2) + " cm /I" + Str(images()\ImageN) + " Do Q"
  ipf_Out(msg)
  If link >= 0
    pdf_Link(x, y, w, h, link)
  EndIf
EndProcedure

ProcedureDLL pdf_Image(FileName$, X.f, Y.f) ;Puts an image in the page.
  pdf_ImageBasic(FileName$,0,0, x, y ,0,0,-1)
EndProcedure

ProcedureDLL pdf_Image2(FileName$, X.f, Y.f, W.f) ;Puts an image in the page.
  pdf_ImageBasic(FileName$,0,0, x, y ,w,0,-1)
EndProcedure

ProcedureDLL pdf_Image3(FileName$, X.f, Y.f, W.f, H.f) ;Puts an image in the page.
  pdf_ImageBasic(FileName$,0,0, x, y ,w, h,-1)
EndProcedure

ProcedureDLL pdf_Image4(FileName$, X.f, Y.f, W.f, H.f, Link.w) ;Puts an image in the page.
  pdf_ImageBasic(FileName$,0,0, x, y ,w, h, link)
EndProcedure

ProcedureDLL pdf_ImageMem(Name$,*Mem,MemSize, X.f, Y.f) ;Puts an image in the page.
  pdf_ImageBasic(Name$,*Mem,MemSize, x, y ,0,0,-1)
EndProcedure

ProcedureDLL pdf_ImageMem2(Name$,*Mem,MemSize, X.f, Y.f, W.f) ;Puts an image in the page.
  pdf_ImageBasic(Name$,*Mem,MemSize, x, y ,w,0,-1)
EndProcedure

ProcedureDLL pdf_ImageMem3(Name$,*Mem,MemSize, X.f, Y.f, W.f, H.f) ;Puts an image in the page.
  pdf_ImageBasic(Name$,*Mem,MemSize, x, y ,w, h,-1)
EndProcedure

ProcedureDLL pdf_ImageMem4(Name$,*Mem,MemSize, X.f, Y.f, W.f, H.f, Link.w) ;Puts an image in the page.
  pdf_ImageBasic(Name$,*Mem,MemSize, x, y ,w, h, link)
EndProcedure

ProcedureDLL pdf_StartPageNums() ;Start TOC page numbering.
  pdfNumbering = #True
  pdfNumberingFooter = #True
EndProcedure
	
ProcedureDLL pdf_StopPageNums() ;Stop TOC page numbering.
  pdfNumbering = #False
EndProcedure	

ProcedureDLL.w pdf_NumPageNum() ;Get TOC page number
  ProcedureReturn pdfNumPageNum
EndProcedure

Procedure pdf_TOCEntryBasic(Text$, level.w)
  AddElement(pdfTOC())
  pdfTOC()\Text$ = Text$
  pdfTOC()\level = level
  pdfTOC()\page = pdf_NumPageNum()
EndProcedure

ProcedureDLL pdf_TOCEntry(Text$) ;Set TOC entry
  pdf_TOCEntryBasic(Text$, 0)
EndProcedure

ProcedureDLL pdf_TOCEntry2(Text$, Level.w) ;Set TOC entry
  pdf_TOCEntryBasic(Text$, level)
EndProcedure

Procedure pdf_InsertTOCBasic(location.w, labelsize.b, entrysize.b, fontfamily$, label$)
  TOCStart.w
  w.f
  h.f
  strsize.f
  PageCellSize.f
  dot.f
  nb.f
  ;make toc at end
	pdf_StopPageNums()
	pdf_AddPageBasic("")
	TOCStart = pdfPage
  pdf_SetFontBasic(FontFamily$, "B", labelSize)
  pdf_cellbasic(0,5,label$,0,1,"C",0,-1)
  pdf_lnBasic(10)
	
	ForEach pdfTOC()
	  level = pdfTOC()\Level
  	If level > 0
	    w = level * 8
	    pdf_Cell(w)    
  	EndIf
	  weight$ = ""
  	If level = 0
	    weight$="B"
  	EndIf
	  String$ = pdfTOC()\Text$
  	pdf_SetFontBasic(FontFamily$, weight$, entrySize)
	  strSize = pdf_GetStringWidth(String$)
  	
	  w=strSize + 2
  	h=pdfFontSize + 2
  	pdf_Cell3(w, h,String$)
	  
   	;Filling dots
	  pdf_SetFontBasic(FontFamily$, "", entrySize)
  	a$=Str(pdfTOC()\Page)
   	PageCellSize=pdf_GetStringWidth(a$)
	  PageCellSize = PageCellSize + 2
		w=pdfW - pdfLMargin - pdfRMargin - PageCellSize - (level*8)-(strsize+2)
 		dot = pdf_GetStringWidth(".")
 		nb=w/dot
 		dots$=""
 		For i = 1 To Int(nb)
 		  dots$ = dots$ + "."
   	Next
	  
 		pdf_CellBasic(w , pdfFontSize + 2 ,dots$, 0, 0, "R", 0, -1)	
 			
   ;Page Number
		pdf_CellBasic(PageCellSize , pdfFontSize + 2 ,a$, 0, 1, "R", 0, -1)				
	Next
		
		
 	;grab it and move to selected location
 	n.w=pdfPage
 	n_toc.w = n - tocstart + 1
  
  Dim last.l(n_toc)
  j = 0
  For i = Tocstart To n
    SelectElement(Pages(), i - 1)
    last(j) = @Pages()
    j = j + 1
  Next
  
  For i = Tocstart - 1 To location Step -1        
    SelectElement(Pages(), i - 1)
    *tmp = @Pages()
    SelectElement(Pages(), i + n_toc -1)
    *second = @Pages()
    SwapElements(Pages(),*tmp , *second)
  Next  
  
   For i=0 To n_toc - 1
     SelectElement(Pages(), location + i -1)
     *second = @Pages()
     SwapElements(Pages(), Last(i), *second)
     
   Next
EndProcedure

ProcedureDLL pdf_InsertTOC() ;Insert table of contents.
  pdf_InsertTOCBasic(1, 20, 10, "Times", "Table of Contents")
EndProcedure

ProcedureDLL pdf_InsertTOC2(Location.w) ;Insert table of contents.
  pdf_InsertTOCBasic(Location, 20, 10, "Times", "Table of Contents")
EndProcedure

ProcedureDLL pdf_InsertTOC3(Location.w, LabelSize.b) ;Insert table of contents.
  pdf_InsertTOCBasic(Location, LabelSize, 10, "Times", "Table of Contents")
EndProcedure

ProcedureDLL pdf_InsertTOC4(Location.w, LabelSize.b, EntrySize.b) ;Insert table of contents.
  pdf_InsertTOCBasic(Location, LabelSize, EntrySize, "Times", "Table of Contents")
EndProcedure

ProcedureDLL pdf_InsertTOC5(Location.w, LabelSize.b, EntrySize.b, FontFamily$) ;Insert table of contents.
  pdf_InsertTOCBasic(Location, LabelSize, EntrySize, FontFamily$, "Table of Contents")
EndProcedure

ProcedureDLL pdf_InsertTOC6(Location.w, LabelSize.b, EntrySize.b, FontFamily$, Label$) ;Insert table of contents.
  pdf_InsertTOCBasic(Location, LabelSize, EntrySize, FontFamily$, Label$)
EndProcedure

ProcedureDLL pdf_GetErrorCode() ;Return the error code.
  ProcedureReturn pdfError
EndProcedure

ProcedureDLL.s pdf_GetErrorMessage() ;Return the error message.
  ProcedureReturn pdfErrorMessage$
EndProcedure

Procedure.s pdf_SkipCellBasic(w.f,h.f,Text$,Border.w=0,Ln.f=0,Align$=#PDF_ALIGN_LEFT,Fill.f=0)
  If pdf_GetStringWidth(Text$) <= w-(0.5*ipf_GetK())
    pdf_CellBasic(w,h,Text$,Border,Ln,Align$,Fill)
  Else
    SkipLen.l=Len(Text$)
    Repeat
      SkipLen-1
      skip$=Left(Text$,SkipLen)+"..."
    Until pdf_GetStringWidth(skip$)<=w-(0.5*ipf_GetK())
    pdf_CellBasic(w,h,skip$,Border,Ln,Align$,Fill)
    ProcedureReturn Right(Text$,Len(Text$)-SkipLen)
  EndIf
EndProcedure

ProcedureDLL.s pdf_SkipCell(w.f,h.f,Text$)
  ProcedureReturn pdf_SkipCellBasic(w.f,h.f,Text$)
EndProcedure

ProcedureDLL.s pdf_SkipCell2(w.f,h.f,Text$,Border.w)
  ProcedureReturn pdf_SkipCellBasic(w.f,h.f,Text$,Border)
EndProcedure

ProcedureDLL.s pdf_SkipCell3(w.f,h.f,Text$,Border.w,Ln.f)
  ProcedureReturn pdf_SkipCellBasic(w.f,h.f,Text$,Border,Ln)
EndProcedure

ProcedureDLL.s pdf_SkipCell4(w.f,h.f,Text$,Border.w,Ln.f,Align$)
  ProcedureReturn pdf_SkipCellBasic(w.f,h.f,Text$,Border,Ln,Align$)
EndProcedure

ProcedureDLL.s pdf_SkipCell5(w.f,h.f,Text$,Border.w,Ln.f,Align$,Fill.f)
  ProcedureReturn pdf_SkipCellBasic(w.f,h.f,Text$,Border,Ln,Align$,Fill)
EndProcedure

DataSection
Zapfdingbats:
  Data.w    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0
  Data.w    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 278, 974, 961, 974
  Data.w  980, 719, 789, 790, 791, 690, 960, 939, 549, 855, 911, 933, 911, 945, 974, 755, 846, 762
  Data.w  761, 571, 677, 763, 760, 759, 754, 494, 552, 537, 577, 692, 786, 788, 788, 790, 793, 794
  Data.w  816, 823, 789, 841, 823, 833, 816, 831, 923, 744, 723, 749, 790, 792, 695, 776, 768, 792
  Data.w  759, 707, 708, 682, 701, 826, 815, 789, 789, 707, 687, 696, 689, 786, 787, 713, 791, 785
  Data.w  791, 873, 761, 762, 762, 759, 759, 892, 892, 788, 784, 438, 138, 277, 415, 392, 392, 668
  Data.w  668,   0, 390, 390, 317, 317, 276, 276, 509, 509, 410, 410, 234, 234, 334, 334,   0,   0
  Data.w    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 732
  Data.w  544, 544, 910, 667, 760, 760, 776, 595, 694, 626, 788, 788, 788, 788, 788, 788, 788, 788
  Data.w  788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 788
  Data.w  788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 788, 894, 838,1016, 458
  Data.w  748, 924, 748, 918, 927, 928, 928, 834, 873, 828, 924, 924, 917, 930, 931, 463, 883, 836
  Data.w  836, 867, 867, 696, 696, 874,   0, 874, 760, 946, 771, 865, 771, 888, 967, 888, 831, 873
  Data.w  927, 970, 918,   0
  
Helvetica:
  Data.w  278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278
  Data.w  278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 355, 556
  Data.w  556, 889, 667, 191, 333, 333, 389, 584, 278, 333, 278, 278, 556, 556, 556, 556, 556, 556
  Data.w  556, 556, 556, 556, 278, 278, 584, 584, 584, 556,1015, 667, 667, 722, 722, 667, 611, 778
  Data.w  722, 278, 500, 667, 556, 833, 722, 778, 667, 778, 722, 667, 611, 722, 667, 944, 667, 667
  Data.w  611, 278, 278, 278, 469, 556, 333, 556, 556, 500, 556, 556, 278, 556, 556, 222, 222, 500
  Data.w  222, 833, 556, 556, 556, 556, 333, 500, 278, 556, 500, 722, 500, 500, 500, 334, 260, 334
  Data.w  584, 350, 556, 350, 222, 556, 333,1000, 556, 556, 333,1000, 667, 333,1000, 350, 611, 350
  Data.w  350, 222, 222, 333, 333, 350, 556,1000, 333,1000, 500, 333, 944, 350, 500, 667, 278, 333
  Data.w  556, 556, 556, 556, 260, 556, 333, 737, 370, 556, 584, 333, 737, 333, 400, 584, 333, 333
  Data.w  333, 556, 537, 278, 333, 333, 365, 556, 834, 834, 834, 611, 667, 667, 667, 667, 667, 667
  Data.w 1000, 722, 667, 667, 667, 667, 278, 278, 278, 278, 722, 722, 778, 778, 778, 778, 778, 584
  Data.w  778, 722, 722, 722, 722, 667, 667, 611, 556, 556, 556, 556, 556, 556, 889, 500, 556, 556
  Data.w  556, 556, 278, 278, 278, 278, 556, 556, 556, 556, 556, 556, 556, 584, 611, 556, 556, 556
  Data.w  556, 500, 556, 500
  
HelveticaB:
  Data.w  278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278
  Data.w  278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 333, 474, 556
  Data.w  556, 889, 722, 238, 333, 333, 389, 584, 278, 333, 278, 278, 556, 556, 556, 556, 556, 556
  Data.w  556, 556, 556, 556, 333, 333, 584, 584, 584, 611, 975, 722, 722, 722, 722, 667, 611, 778
  Data.w  722, 278, 556, 722, 611, 833, 722, 778, 667, 778, 722, 667, 611, 722, 667, 944, 667, 667
  Data.w  611, 333, 278, 333, 584, 556, 333, 556, 611, 556, 611, 556, 333, 611, 611, 278, 278, 556
  Data.w  278, 889, 611, 611, 611, 611, 389, 556, 333, 611, 556, 778, 556, 556, 500, 389, 280, 389
  Data.w  584, 350, 556, 350, 278, 556, 500,1000, 556, 556, 333,1000, 667, 333,1000, 350, 611, 350
  Data.w  350, 278, 278, 500, 500, 350, 556,1000, 333,1000, 556, 333, 944, 350, 500, 667, 278, 333
  Data.w  556, 556, 556, 556, 280, 556, 333, 737, 370, 556, 584, 333, 737, 333, 400, 584, 333, 333
  Data.w  333, 611, 556, 278, 333, 333, 365, 556, 834, 834, 834, 611, 722, 722, 722, 722, 722, 722
  Data.w 1000, 722, 667, 667, 667, 667, 278, 278, 278, 278, 722, 722, 778, 778, 778, 778, 778, 584
  Data.w  778, 722, 722, 722, 722, 667, 667, 611, 556, 556, 556, 556, 556, 556, 889, 556, 556, 556
  Data.w  556, 556, 278, 278, 278, 278, 611, 611, 611, 611, 611, 611, 611, 584, 611, 611, 611, 611
  Data.w  611, 556, 611, 556
  
HelveticaI:
  Data.w  278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278
  Data.w  278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 355, 556
  Data.w  556, 889, 667, 191, 333, 333, 389, 584, 278, 333, 278, 278, 556, 556, 556, 556, 556, 556
  Data.w  556, 556, 556, 556, 278, 278, 584, 584, 584, 556,1015, 667, 667, 722, 722, 667, 611, 778
  Data.w  722, 278, 500, 667, 556, 833, 722, 778, 667, 778, 722, 667, 611, 722, 667, 944, 677, 677
  Data.w  611, 278, 278, 278, 469, 556, 333, 556, 556, 500, 556, 556, 278, 556, 556, 222, 222, 500
  Data.w  222, 833, 556, 556, 556, 556, 333, 500, 278, 556, 500, 722, 500, 500, 500, 334, 260, 334
  Data.w  584, 350, 556, 350, 222, 556, 333,1000, 556, 556, 333,1000, 667, 333,1000, 350, 611, 350
  Data.w  350, 222, 222, 333, 333, 350, 556,1000, 333,1000, 500, 333, 944, 350, 500, 667, 278, 333
  Data.w  556, 556, 556, 556, 260, 556, 333, 737, 370, 556, 584, 333, 737, 333, 400, 584, 333, 333
  Data.w  333, 556, 537, 278, 333, 333, 365, 556, 834, 834, 834, 611, 667, 667, 667, 667, 667, 667
  Data.w 1000, 722, 667, 667, 667, 667, 278, 278, 278, 278, 722, 722, 778, 778, 778, 778, 778, 584
  Data.w  778, 722, 722, 722, 722, 667, 667, 611, 556, 556, 556, 556, 556, 556, 889, 500, 556, 556
  Data.w  556, 556, 278, 278, 278, 278, 556, 556, 556, 556, 556, 556, 556, 584, 611, 556, 556, 556
  Data.w  556, 500, 556, 500
  
HelveticaBI:
  Data.w  278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278
  Data.w  278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 333, 474, 556
  Data.w  556, 889, 722, 238, 333, 333, 389, 584, 278, 333, 278, 278, 556, 556, 556, 556, 556, 556
  Data.w  556, 556, 556, 556, 333, 333, 584, 584, 584, 611, 975, 722, 722, 722, 722, 667, 611, 778
  Data.w  722, 278, 556, 722, 611, 833, 722, 778, 667, 778, 722, 667, 611, 722, 667, 944, 667, 667
  Data.w  611, 333, 278, 333, 584, 556, 333, 556, 611, 556, 611, 556, 333, 611, 611, 278, 278, 556
  Data.w  278, 889, 611, 611, 611, 611, 389, 556, 333, 611, 556, 778, 556, 556, 500, 389, 280, 389
  Data.w  584, 350, 556, 350, 278, 556, 500,1000, 556, 556, 333,1000, 667, 333,1000, 350, 611, 350
  Data.w  350, 278, 278, 500, 500, 350, 556,1000, 333,1000, 556, 333, 944, 350, 500, 667, 278, 333
  Data.w  556, 556, 556, 556, 280, 556, 333, 737, 370, 556, 584, 333, 737, 333, 400, 584, 333, 333
  Data.w  333, 611, 556, 278, 333, 333, 365, 556, 834, 834, 834, 611, 722, 722, 722, 722, 722, 722
  Data.w 1000, 722, 667, 667, 667, 667, 278, 278, 278, 278, 722, 722, 778, 778, 778, 778, 778, 584
  Data.w  778, 722, 722, 722, 722, 667, 667, 611, 556, 556, 556, 556, 556, 556, 889, 556, 556, 556
  Data.w  556, 556, 278, 278, 278, 278, 611, 611, 611, 611, 611, 611, 611, 584, 611, 611, 611, 611
  Data.w  611, 556, 611, 556

Times:
  Data.w  250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250
  Data.w  250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 333, 408, 500
  Data.w  500, 833, 778, 180, 333, 333, 500, 564, 250, 333, 250, 278, 500, 500, 500, 500, 500, 500
  Data.w  500, 500, 500, 500, 278, 278, 564, 564, 564, 444, 921, 722, 667, 667, 722, 611, 556, 722
  Data.w  722, 333, 389, 722, 611, 889, 722, 722, 556, 722, 667, 556, 611, 722, 722, 944, 722, 722
  Data.w  611, 333, 278, 333, 469, 500, 333, 444, 500, 444, 500, 444, 333, 500, 500, 278, 278, 500
  Data.w  278, 778, 500, 500, 500, 500, 333, 389, 278, 500, 500, 722, 500, 500, 444, 480, 200, 480
  Data.w  541, 350, 500, 350, 333, 500, 444,1000, 500, 500, 333,1000, 556, 333, 889, 350, 611, 350
  Data.w  350, 333, 333, 444, 444, 350, 500,1000, 333, 980, 389, 333, 722, 350, 444, 722, 250, 333
  Data.w  500, 500, 500, 500, 200, 500, 333, 760, 276, 500, 564, 333, 760, 333, 400, 564, 300, 300
  Data.w  333, 500, 453, 250, 333, 300, 310, 500, 750, 750, 750, 444, 722, 722, 722, 722, 722, 722
  Data.w  889, 667, 611, 611, 611, 611, 333, 333, 333, 333, 722, 722, 722, 722, 722, 722, 722, 564
  Data.w  722, 722, 722, 722, 722, 722, 556, 500, 444, 444, 444, 444, 444, 444, 667, 444, 444, 444
  Data.w  444, 444, 278, 278, 278, 278, 500, 500, 500, 500, 500, 500, 500, 564, 500, 500, 500, 500
  Data.w  500, 500, 500, 500
 
TimesB:
  Data.w  250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250
  Data.w  250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 333, 555, 500
  Data.w  500,1000, 833, 278, 333, 333, 500, 570, 250, 333, 250, 278, 500, 500, 500, 500, 500, 500
  Data.w  500, 500, 500, 500, 333, 333, 570, 570, 570, 500, 930, 722, 667, 722, 722, 667, 611, 778
  Data.w  778, 389, 500, 778, 667, 944, 722, 778, 611, 778, 722, 556, 667, 722, 722,1000, 722, 722
  Data.w  667, 333, 278, 333, 581, 500, 333, 500, 556, 444, 556, 444, 333, 500, 556, 278, 333, 556
  Data.w  278, 833, 556, 500, 556, 556, 444, 389, 333, 556, 500, 722, 500, 500, 444, 394, 220, 394
  Data.w  520, 350, 500, 350, 333, 500, 500,1000, 500, 500, 333,1000, 556, 333,1000, 350, 667, 350
  Data.w  350, 333, 333, 500, 500, 350, 500,1000, 333,1000, 389, 333, 722, 350, 444, 722, 250, 333
  Data.w  500, 500, 500, 500, 220, 500, 333, 747, 300, 500, 570, 333, 747, 333, 400, 570, 300, 300
  Data.w  333, 556, 540, 250, 333, 300, 330, 500, 750, 750, 750, 500, 722, 722, 722, 722, 722, 722
  Data.w 1000, 722, 667, 667, 667, 667, 389, 389, 389, 389, 722, 722, 778, 778, 778, 778, 778, 570
  Data.w  778, 722, 722, 722, 722, 722, 611, 556, 500, 500, 500, 500, 500, 500, 722, 444, 444, 444
  Data.w  444, 444, 278, 278, 278, 278, 500, 556, 500, 500, 500, 500, 500, 570, 500, 556, 556, 556
  Data.w  556, 500, 556, 500 

TimesI:
  Data.w  250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250
  Data.w  250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 333, 420, 500
  Data.w  500, 833, 778, 214, 333, 333, 500, 675, 250, 333, 250, 278, 500, 500, 500, 500, 500, 500
  Data.w  500, 500, 500, 500, 333, 333, 675, 675, 675, 500, 920, 611, 611, 667, 722, 611, 611, 722
  Data.w  722, 333, 444, 667, 556, 833, 667, 722, 611, 722, 611, 500, 556, 722, 611, 833, 611, 556
  Data.w  556, 389, 278, 389, 422, 500, 333, 500, 500, 444, 500, 444, 278, 500, 500, 278, 278, 444
  Data.w  278, 722, 500, 500, 500, 500, 389, 389, 278, 500, 444, 667, 444, 444, 389, 400, 275, 400
  Data.w  541, 350, 500, 350, 333, 500, 556, 889, 500, 500, 333,1000, 500, 333, 944, 350, 556, 350
  Data.w  350, 333, 333, 556, 556, 350, 500, 889, 333, 980, 389, 333, 667, 350, 389, 556, 250, 389
  Data.w  500, 500, 500, 500, 275, 500, 333, 760, 276, 500, 675, 333, 760, 333, 400, 675, 300, 300
  Data.w  333, 500, 523, 250, 333, 300, 310, 500, 750, 750, 750, 500, 611, 611, 611, 611, 611, 611
  Data.w  889, 667, 611, 611, 611, 611, 333, 333, 333, 333, 722, 667, 722, 722, 722, 722, 722, 675
  Data.w  722, 722, 722, 722, 722, 556, 611, 500, 500, 500, 500, 500, 500, 500, 667, 444, 444, 444
  Data.w  444, 444, 278, 278, 278, 278, 500, 500, 500, 500, 500, 500, 500, 675, 500, 500, 500, 500
  Data.w  500, 444, 500, 444

TimesBI:
  Data.w  250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250
  Data.w  250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 389, 555, 500
  Data.w  500, 833, 778, 278, 333, 333, 500, 570, 250, 333, 250, 278, 500, 500, 500, 500, 500, 500
  Data.w  500, 500, 500, 500, 333, 333, 570, 570, 570, 500, 832, 667, 667, 667, 722, 667, 667, 722
  Data.w  778, 389, 500, 667, 611, 889, 722, 722, 611, 722, 667, 556, 611, 722, 667, 889, 667, 611
  Data.w  611, 333, 278, 333, 570, 500, 333, 500, 500, 444, 500, 444, 333, 500, 556, 278, 278, 500
  Data.w  278, 778, 556, 500, 500, 500, 389, 389, 278, 556, 444, 667, 500, 444, 389, 348, 220, 348
  Data.w  570, 350, 500, 350, 333, 500, 500,1000, 500, 500, 333,1000, 556, 333, 944, 350, 611, 350
  Data.w  350, 333, 333, 500, 500, 350, 500,1000, 333,1000, 389, 333, 722, 350, 389, 611, 250, 389
  Data.w  500, 500, 500, 500, 220, 500, 333, 747, 266, 500, 606, 333, 747, 333, 400, 570, 300, 300
  Data.w  333, 576, 500, 250, 333, 300, 300, 500, 750, 750, 750, 500, 667, 667, 667, 667, 667, 667
  Data.w  944, 667, 667, 667, 667, 667, 389, 389, 389, 389, 722, 722, 722, 722, 722, 722, 722, 570
  Data.w  722, 722, 722, 722, 722, 611, 611, 500, 500, 500, 500, 500, 500, 500, 722, 444, 444, 444
  Data.w  444, 444, 278, 278, 278, 278, 500, 556, 500, 500, 500, 500, 500, 570, 500, 556, 556, 556
  Data.w  556, 444, 500, 444

Symbol:
  Data.w  250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250
  Data.w  250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 250, 333, 713, 500
  Data.w  549, 833, 778, 439, 333, 333, 500, 549, 250, 549, 250, 278, 500, 500, 500, 500, 500, 500
  Data.w  500, 500, 500, 500, 278, 278, 549, 549, 549, 444, 549, 722, 667, 722, 612, 611, 763, 603
  Data.w  722, 333, 631, 722, 686, 889, 722, 722, 768, 741, 556, 592, 611, 690, 439, 768, 645, 795
  Data.w  611, 333, 863, 333, 658, 500, 500, 631, 549, 549, 494, 439, 521, 411, 603, 329, 603, 549
  Data.w  549, 576, 521, 549, 549, 521, 549, 603, 439, 576, 713, 686, 493, 686, 494, 480, 200, 480
  Data.w  549,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0
  Data.w    0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 750, 620
  Data.w  247, 549, 167, 713, 500, 753, 753, 753, 753,1042, 987, 603, 987, 603, 400, 549, 411, 549
  Data.w  549, 713, 494, 460, 549, 549, 549, 549,1000, 603,1000, 658, 823, 686, 795, 987, 768, 768
  Data.w  823, 768, 768, 713, 713, 713, 713, 713, 713, 713, 768, 713, 790, 790, 890, 823, 549, 250
  Data.w  713, 603, 603,1042, 987, 603, 987, 603, 494, 329, 790, 790, 786, 713, 384, 384, 384, 384
  Data.w  384, 384, 494, 494, 494, 494,   0, 329, 274, 686, 686, 686, 384, 384, 384, 384, 384, 384
  Data.w  494, 494, 494,   0
  
EndDataSection

;1 = "16-bit depth PNG not supported."
;2 = "Alpha channel PNG not supported."
;3 = "Unknown compression PNG method."
;4 = "Unknown filter PNG method."
;5 = "Interlacing PNG not supported."
;6 = "Missing palette in PNG"
;7 = "This JPEG file is not supported"
;8 = "Can't open image file : "
;9 = "Problem reading image file in memory : "
;10 = "JFIF marker is missing "
;11 = not a JPEG file."
;12 = incorrect PNG file.
;13 = not a JPEG or PNG file."
;14 = filename is not correct.
;15 = Can't create the file
; IDE Options = PureBasic 4.10 (Windows - x86)
; CursorPosition = 19
; Folding = -------------------------------
; EnableUnicode